/*****************************************************************************
 *
 * \file
 *
 * \brief Stdio ريǗ
 *
 * ̨قAVR޲Stdio ر ̪ɑ΂ėLpȊ֐̑g`܂B
 *
 * 쌠 (c) 2009-2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 ******************************************************************************/


#ifndef _STDIO_SERIAL_H_
#define _STDIO_SERIAL_H_

/**
 * \defgroup group_common_utils_stdio_stdio_serial WرI/O(stdio)
 * \ingroup group_common_utils_stdio
 *
 * AVR޲stdio ر ̪鋤ʕWرI/OǗײ
 *
 * \{
 */

#include <stdio.h>
#include "compiler.h"
#include "sysclk.h"
#include "serial.h"

#if XMEGA && defined(__GNUC__)
	extern int _write (char c, int *f);
	extern int _read (int *f);
#endif


//! stdioɎgpUSARTPʕ̂̊ւ̈ʒuwq
extern volatile void *volatile stdio_base;
//! Oʏ݊֐ւ̈ʒuwq
extern int (*ptr_put)(void volatile*,int);
//! Oʓǂݍ݊֐ւ̈ʒuwq
extern void (*ptr_get)(void volatile*,int*);

/*! \brief stdioرٓŏ
 *
 * \param	usart	USART̂̊ڽ
 * \param	opt		RS232ʐMɕKvȔCӑI(\ref usart_options_tB)
 *
 */
static inline void stdio_serial_init(volatile void *usart, const usart_serial_options_t *opt)
{
	stdio_base = (void *)usart;
	ptr_put = (int (*)(void volatile*,int))&usart_serial_putchar;
	ptr_get = (void (*)(void volatile*,int*))&usart_serial_getchar;
	#if XMEGA
		usart_serial_init((USART_t *)usart,opt);
	#elif UC3
		usart_serial_init(usart,(usart_serial_options_t *)opt);
	#else
		usart_serial_init((Uart *)usart,(usart_serial_options_t *)opt);
	#endif
	// AVR GCC libcɊւďo޲ڸĂfdevopengp
	#if XMEGA && defined(__GNUC__)
		fdevopen((int (*)(char, FILE*))(_write),(int (*)(FILE*))(_read));	// printf޲ڸėp
	#endif
}

/**
 * \}
 */

#endif  // _STDIO_SERIAL_H_
