/**
 * \file
 *
 * \brief AVR XMEGA A/Dϊײ
 *
 * 쌠 (C) 2010-2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef ADC_H
#define ADC_H

#include <compiler.h>
#include <conf_adc.h>
#include <nvm.h>
#include <parts.h>
#include <sleepmgr.h>
#include <sysclk.h>

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \defgroup adc_group A/Dϊ(ADC)
 *
 * AVR XMEGA ADCpײނłBADCPʕƂ̌ق̋A
 * ~A`Ԑݒp̊֐񋟂܂B
 *
 * ײAPI͎2̕ɕ܂B:
 * - \ref adc_channel_group
 * - \ref adc_module_group
 *
 * API͌`Ԑݒ܂ލ\̂gp܂B̍\̂͂̌`Ԑݒ肪ADCP
 * ʕ܂͂ق1̂ǂ炩ɏOɏȂ΂Ȃ܂
 * B
 *
 * ADC`Ԑݒ肳Ă܂Aǂȕϊs꓾̂ɐ旧Ăꂪ
 * Ȃ΂Ȃ܂Bmȕϊۏ؂邽߁AADCPʕƕϊJn
 * ̊ԂɍŒAw肳ꂽnԑ҂ĂBwǂXMEGA޲̎nԂ
 * ő24 ADCۯɎw肳Ă܂Bgp޲ɑ΂nԂmF
 * B
 *
 * \note SĂ޲ŋLqꂽ֐̑SĂp\Ȗł͂܂B
 * ADC@\̑gł̈Ⴂ̂߂łB޲ɑ΂Ăǂ̋@\p\̏ڍׂ
 * Ă޲̎ްĂQƂĂB
 *
 * \note `Ԑݒ̍쐬/ύXp֐͊荞݂ɑ΂ĕی삳܂BADCڼ޽
 * ɑ΂ēǂݏ֐͑̒Lی삳܂B
 *
 * \section dependencies ˑ
 * ײނ͈ȉ̒PʕɈˑ܂B
 * - \ref Ӌ@\ۯpsysclk_group
 * - \ref ꂽx~ݒpsleepmgr_group
 * - \ref HZް擾pnvm_group
 * - \ref ISR`Ədvޗ̈撆̊荞݋֎~pinterrupt_group
 * @{
 */

/**
 * \internal
 * \name ΍`
 *
 * \todo ޲ ͯ ̧قł̒`sp΍폜
 * @{
 */
  
#ifndef ADC_CH_OFFSET_gp
#define ADC_CH_OFFSET_gp				4 
#endif  

#define ADC_EVACT_SYNCHSWEEP_tmpfix_gc	0x06

#define ADC_CH_GAIN_DIV2_tmpfix_gc		(0x07 << 2)

#define ADC_CURRLIMIT_tmpfix_gm			(0x03 << 5)

typedef enum ADC_CURRLIMIT_tmpfix_enum {
	ADC_CURRLIMIT_NO_tmpfix_gc			= (0x00 << 5),
	ADC_CURRLIMIT_SMALL_tmpfix_gc		= (0x01 << 5),
	ADC_CURRLIMIT_MEDIUM_tmpfix_gc		= (0x02 << 5),
	ADC_CURRLIMIT_LARGE_tmpfix_gc		= (0x03 << 5),
} ADC_CURRLIMIT_tmpfix_t;

/* IARp݊ϸ */
#if defined(__ICCAVR__)
#  define _WORDREGISTER WORDREGISTER
#endif

typedef struct ADC_CH_tmpfix_struct {
	register8_t CTRL;
	register8_t MUXCTRL;
	register8_t INTCTRL;
	register8_t INTFLAGS;
	_WORDREGISTER(RES);
	register8_t SCAN;
	register8_t reserved_0x07;
} ADC_CH_tmpfix_t;
/** @} */

/**
 * \defgroup adc_module_group ADCPʕ
 *
 * ADCPʕpǗƌ`Ԑݒ̊֐
 *
 * API̊֐ƒ`͎3̌Qɕ邱Ƃł܂B:
 * - 荞݌Ăі߂: 荞݌Ăі߂֐̌`ԐݒƐݒ
 * - PʕǗ: ADC̋/֎~AϊJnA荞׸ގ擾Ȃǂɑ΂钼ڱ
 * - Pʕ`Ԑݒ: `Ԑݒ̍쐬/ύXADCɑ΂邻̓ǂݏ
 *
 * @{
 */

/**
 * \def ADC_NR_OF_CHANNELS
 * \brief ADCِ
 */
#if XMEGA_A || XMEGA_AU
#  define ADC_NR_OF_CHANNELS	4
#elif XMEGA_B || XMEGA_C || XMEGA_D
#  define ADC_NR_OF_CHANNELS	1
#endif

/**
 * \def CONFIG_ADC_VERSION
 * \brief XMEGA ADC
 *
 * ײނXMEGA ADC2̔łx܂B2ł͑SĂXMEGA AUABAC޲
 * ŌAdA͑AGNDAVcc/2QƊA1/2x͗
 * B̼قײނǂ̔łxׂَ߲ɐ䂷̂Ɏgp
 * B
 *
 * XMEGA AUABAC޲ɑ΂āA̼ق͎I2ƂĒ`܂B
 * ޲ɑ΂āA̼ق͊1ɂ܂Aconf_adc.hł`邱
 * ɂď㏑邱Ƃł܂B
 */
#if XMEGA_AU || XMEGA_B || XMEGA_C || defined(__DOXYGEN__)
#  define CONFIG_ADC_VERSION    2
#elif !defined(CONFIG_ADC_VERSION)
#  define CONFIG_ADC_VERSION    1
#endif

/** ADC`Ԑݒ */
struct adc_config {
#if ADC_NR_OF_CHANNELS > 1
	/* DMAQvCTRLAɊi[܂B */
	uint8_t ctrla;
#endif
	uint8_t ctrlb;
	uint8_t refctrl;
	uint8_t evctrl;
	uint8_t prescaler;
	uint16_t cmp;
};

/**
 * \name Zް ڽ
 * \note xmZ͐ێ85̕Ȃ12ޯĕϊō̎悳܂B
 */
/** @{ */

#define ADCACAL0	offsetof(NVM_PROD_SIGNATURES_t, ADCACAL0)	/**< ADC A,Z޲0 */
#define ADCACAL1	offsetof(NVM_PROD_SIGNATURES_t, ADCACAL1)	/**< ADC A,Z޲1 */
#define ADCBCAL0	offsetof(NVM_PROD_SIGNATURES_t, ADCBCAL0)	/**< ADC B,Z޲0 */
#define ADCBCAL1	offsetof(NVM_PROD_SIGNATURES_t, ADCBCAL1)	/**< ADC B,Z޲1 */
#define TEMPSENSE0	offsetof(NVM_PROD_SIGNATURES_t, TEMPSENSE0)	/**< xmZ޲0 */
#define TEMPSENSE1	offsetof(NVM_PROD_SIGNATURES_t, TEMPSENSE1)	/**< xmZ޲1 */

/** @} */

/** \brief ADCZް */
enum adc_calibration_data {
	ADC_CAL_ADCA,	/**< ADC A߲ײݍZް */
	ADC_CAL_ADCB,	/**< ADC B߲ײݍZް */

	/**
	 * \brief xmZް
	 * \note ؎358.15ɓێ85ő肵Ȃ12ޯ
	 */
	ADC_CAL_TEMPSENSE,
};

/** \name ADCَՕ */
/** @{ */

#define ADC_CH0		(1U << 0)	/**< ADC0 */

#if XMEGA_A || XMEGA_AU || defined(__DOXYGEN__)
#  define ADC_CH1	(1U << 1)	/**< ADC1 */
#  define ADC_CH2	(1U << 2)	/**< ADC2 */
#  define ADC_CH3	(1U << 3)	/**< ADC3 */
#endif

/** @} */

/** \name ADC͎Օ */
/** @{ */

#define ADC_INT_TEMPSENSE	ADC_TEMPREF_bm	/**< xm */
#define ADC_INT_BANDGAP		ADC_BANDGAP_bm	/**< ޷ެߎQƊ */

/** @} */

/**
 * \brief ADCϊNݒ
 *
 * \note ϊNł̑I޲nԂŕς܂Bڍ׏ɂĂ޲
 * QƂĂB
 */
enum adc_trigger {
	/** 蓮Nϊ */
	ADC_TRIG_MANUAL,

	/**
	 * \brief Rsϊ|
	 * \note ADCƒɊJn܂B
	 */
	ADC_TRIG_FREERUN_SWEEP,

	/**
	 * \brief قł̎ۋNꂽϊ
	 * ADCقeقƑ΂ɂ܂B
	 * \note gp邱Ƃłő{ق͕ϊN邽߂ِ
	 * Č߂܂B
	 */
	ADC_TRIG_EVENT_SINGLE,

#if ADC_NR_OF_CHANNELS > 1

	/**
	 * \brief ۋNꂽϊ|
	 * \note ̓ł͊{قgp܂B
	 */
	ADC_TRIG_EVENT_SWEEP,
#endif

#if XMEGA_A || (CONFIG_ADC_VERSION == 2)

	/**
	 * \brief ۋNꂽϊ|
	 * \note ̓ł͊{قgp܂B
	 */
	ADC_TRIG_EVENT_SYNCSWEEP,
#endif
};

/** \brief ADCLݒ */
enum adc_sign {
	ADC_SIGN_OFF,					/**< Ȃϊ */
	ADC_SIGN_ON = ADC_CONMODE_bm,	/**< tϊ */
};

/** \brief ADC\ݒ */
enum adc_resolution {
	ADC_RES_8       = ADC_RESOLUTION_8BIT_gc,		/**< E8ޯĕ\ */
	ADC_RES_12      = ADC_RESOLUTION_12BIT_gc,		/**< E12ޯĕ\ */
	ADC_RES_12_LEFT = ADC_RESOLUTION_LEFT12BIT_gc,	/**< 12ޯĕ\ */
};

/**
 * \brief ADCdݒ
 *
 * \note dł̑I޲nԂŕς܂AڍׂȏɂĂ޲
 * ̎QƂĂB
 */
enum adc_reference {
	ADC_REF_BANDGAP  = ADC_REFSEL_INT1V_gc,		/**< 1V޷ެߊd */
	ADC_REF_VCC      = ADC_REFSEL_VCC_gc,		/**< VCC/1.6 */
#if !XMEGA_B3 || defined(__DOXYGEN__)
	ADC_REF_AREFA    = ADC_REFSEL_AREFA_gc,		/**< AEREFA݂ł̊Od */
#endif
	ADC_REF_AREFB    = ADC_REFSEL_AREFB_gc,		/**< AREFB݂ł̊Od */
#if CONFIG_ADC_VERSION == 2
	ADC_REF_VCCDIV2 = ADC_REFSEL_VCCDIV2_gc,	/**< VCC/2 */
#endif
};

/** \name ײޗp֐ */
/** @{ */

/**
 * \internal
 * \brief َՕADCوʒuwq擾
 *
 * \param	adc			ADCPʕւ̈ʒuwq
 * \param	ch_mask		ADCق̎Օ:
 *						\arg \c ADC_CHnA\c nقw(Pق
 *						Օŗ^邱Ƃł܂B)
 *
 * \return	ADCقւ̈ʒuwq
 */
__always_inline ADC_CH_tmpfix_t *adc_get_channel(ADC_t *adc, uint8_t ch_mask);

__always_inline ADC_CH_tmpfix_t *adc_get_channel(ADC_t *adc, uint8_t ch_mask)
{
	uint8_t index = 0;

	Assert(ch_mask & ((1 << ADC_NR_OF_CHANNELS) - 1));

	/* œK̂߂ɏtײctzgp */
#if ADC_NR_OF_CHANNELS > 4
	if (!(ch_mask & 0x0f)) {
		index += 4;
		ch_mask >>= 4;
	}
#endif
#if ADC_NR_OF_CHANNELS > 2
	if (!(ch_mask & 0x03)) {
		index += 2;
		ch_mask >>= 2;
	}
#endif
#if ADC_NR_OF_CHANNELS > 1
	if (!(ch_mask & 0x01)) {
		index++;
	}
#endif

	return (ADC_CH_tmpfix_t *)(&adc->CH0 + index);
}

/** @} */

#if defined(CONFIG_ADC_CALLBACK_ENABLE) || defined(__DOXYGEN__)
/** \name ADC荞݌Ăі߂֐ */
/** @{ */

/**
 * \def CONFIG_ADC_CALLBACK_ENABLE
 * \brief ADC荞݂ł̌Ăі߂邽߂̌`Ԑݒ
 *
 * ADC荞݂ŌĂі߂ɂ\ref conf_adc.hł̼ق`Ă
 * B\ref adc_callback_t^̊֐gp҂ɂĒ`Ag߂
 * \ref adc_set_callbackײނ`Ԑݒ肳Ȃ΂Ȃ܂B
 */
#if !defined(CONFIG_ADC_CALLBACK_ENABLE) || defined(__DOXYGEN__)
#  define CONFIG_ADC_CALLBACK_ENABLE
#endif

/**
 * \def CONFIG_ADC_CALLBACK_TYPE
 * \brief Ăі߂pҰް^p`Ԑݒ
 *
 * Ăі߂֐pADCϊҰް^`B͕ϊ̗̕Lƕ
 * \ɏ]Ē`ׂłB:
 * - t12ޯĂɑ΂āA\c int16_t
 * - Ȃ12ޯĂɑ΂āA\c uint16_t (^)
 * - t8ޯĂɑ΂āA\c int8_t
 * - Ȃ8ޯĂɑ΂āA\c uint8_t
 *
 * ް^]܂ȂꍇA\ref conf_adc.hł`ĂB
 */
#if !defined(CONFIG_ADC_CALLBACK_TYPE) || defined(__DOXYGEN__)
#  define CONFIG_ADC_CALLBACK_TYPE    uint16_t
#endif

/** Ăі߂pADCϊҰް^ */
typedef CONFIG_ADC_CALLBACK_TYPE adc_result_t;

/**
 * \brief ADC荞݌Ăі߂֐ʒuwq
 *
 * \param	adc			ADCPʕւ̈ʒuwq
 * \param	ch_mask		ADCق̎Օ:
 *						\arg \c ADC_CHnA\c nقw(PقՕŗ^邱Ƃł܂B)
 * \param	res			ADCϊ
 */
typedef void (*adc_callback_t)(ADC_t *adc, uint8_t ch_mask, adc_result_t res);

void adc_set_callback(ADC_t *adc, adc_callback_t callback);

/** @} */
#endif

/** \name ADCPʕǗ */
/** @{ */

void adc_enable(ADC_t *adc);
void adc_disable(ADC_t *adc);
bool adc_is_enabled(ADC_t *adc);

/**
 * \brief ADCقł̒PϊJn
 *
 * \param	adc			ADCPʕւ̈ʒuwq
 * \param	ch_mask		ADCق̎Օ:
 *						\arg \c ADC_CHnA\c nقw(͋OR
 *						꓾܂B)
 *
 * \note ̊֐ɑ΂Ăǂ̌ʂ߂ADCȂ΂Ȃ܂B
 */
static inline void adc_start_conversion(ADC_t *adc, uint8_t ch_mask)
{
	irqflags_t flags = cpu_irq_save();
	adc->CTRLA |= ch_mask << ADC_CH0START_bp;
	cpu_irq_restore(flags);
}

/**
 * \brief ADCق猋ʂ擾
 *
 * ADCقŐV̕ϊʂ擾
 *
 * \param	adc			ADCPʕւ̈ʒuwq
 * \param	ch_mask		ADCق̎Օ:
 *						\arg \c ADC_CHnA\c nقw(Pق
 *						Օŗ^邱Ƃł܂B)
 *
 * \return ADCق̍ŐV̕ϊʁB̗L͖֌W
 *
 * \note ϸۂ16ޯēǂݍ݂荞݂ی삵܂BϸێsɊ
 * ݂ADCɑ΂16ޯĂ̓ǂݍ݂܂͏݂sȂꍇAǂ
 * ݂̕s邽߂Ɋ荞݂ꎞIɋ֎~Ȃ΂Ȃ܂B
 */
#define adc_get_result(adc, ch_mask)    (adc_get_channel(adc, ch_mask)->RES)

/**
 * \brief ADCق畄ťʂ擾
 *
 * 16ޯēǂݍ݂̊荞ݕیADCق畄t^ƂčŐV̕ϊʂ
 * ܂B
 *
 * \param	adc			ADCPʕւ̈ʒuwq
 * \param	ch_mask		ADCق̎Օ:
 *						\arg \c ADC_CHnA\c nقw(Pق
 *						Օŗ^邱Ƃł܂B)
 *
 * \return	t16ޯĐƂADCق̍ŐV̕ϊ
 */
static inline int16_t adc_get_signed_result(ADC_t *adc, uint8_t ch_mask)
{
	int16_t val;
	irqflags_t flags;
	ADC_CH_tmpfix_t *adc_ch;

	adc_ch = adc_get_channel(adc, ch_mask);

	flags = cpu_irq_save();
	val = adc_ch->RES;
	cpu_irq_restore(flags);

	return val;
}

/**
 * \brief ADCق畄Ȃ̌ʂ擾
 *
 * 16ޯēǂݍ݂̊荞ݕیŁAADCق畄Ȃ^ƂčŐV̕ϊʂ
 * Ԃ܂B
 *
 * \param	adc			ADCPʕւ̈ʒuwq
 * \param	ch_mask		ADCق̎Օ:
 *						\arg \c ADC_CHnA\c nقw(Pق
 *						Օŗ^邱Ƃł܂B)
 *
 * \return	Ȃ16ޯĐƂADCق̍ŐV̕ϊ
 */
static inline uint16_t adc_get_unsigned_result(ADC_t *adc, uint8_t ch_mask)
{
	uint16_t val;
	irqflags_t flags;
	ADC_CH_tmpfix_t *adc_ch;

	adc_ch = adc_get_channel(adc, ch_mask);

	flags = cpu_irq_save();
	val = adc_ch->RES;
	cpu_irq_restore(flags);

	return val;
}

/**
 * \brief ADCق̊荞׸ނ擾
 *
 * ՕȂق̊荞׸ނԂ܂B荞׸ނ̈Ӗ͌قǂ
 * 삩Ɉˑ܂B
 *
 * \param	adc			ADCPʕւ̈ʒuwq
 * \param	ch_mask		ADCق̎Օ:
 *						\arg \c ADC_CHnA\c nقw(͋OR
 *						꓾܂B)
 *
 * \return	荞׸ނł̎Օ
 */
static inline uint8_t adc_get_interrupt_flag(ADC_t *adc, uint8_t ch_mask)
{
	return (adc->INTFLAGS >> ADC_CH0IF_bp) & ch_mask;
}

/**
 * \brief ADCق̊荞׸ނ
 *
 * \param	adc			ADCPʕւ̈ʒuwq
 * \param	ch_mask		ADCق̎Օ:
 *						\arg \c ADC_CHnA\c nقw(͋OR
 *						꓾܂B)
 *
 * \note ̊֐ɑ΂Ăǂ̌ʂ߂ADCȂ΂Ȃ܂B
 */
static inline void adc_clear_interrupt_flag(ADC_t *adc, uint8_t ch_mask)
{
	adc->INTFLAGS = ch_mask << ADC_CH0IF_bp;
}

/**
 * \brief ADCق̊荞׸ޑ҂
 *
 * w肵ق̊荞׸ނ̐ݒ҂A߂Oɂ܂B
 * قՕꍇA֐\a SĂ̊荞׸ނ̐ݒ҂܂B
 *
 * \param	adc			ADCPʕւ̈ʒuwq
 * \param	ch_mask		ADCق̎Օ:
 *						\arg \c ADC_CHnA\c nقw(͋OR
 *						꓾܂B)
 */
static inline void adc_wait_for_interrupt_flag(ADC_t *adc, uint8_t ch_mask)
{
	do { } while (adc_get_interrupt_flag(adc, ch_mask) != ch_mask);
	adc_clear_interrupt_flag(adc, ch_mask);
}

/**
 * \brief ADCj
 *
 * iŝǂ̕ϊ~邱ƂADCɋA̎Ӌ@\ۯł̸ۯ
 * Ďn܂Bۗ̕ϊ͸ۯ ؾČɊJn܂B
 *
 * \param adc ADCPʕւ̈ʒuwq
 *
 * \note ̊֐ɑ΂Ăǂ̌ʂ߂ADCȂ΂Ȃ܂B
 */
static inline void adc_flush(ADC_t *adc)
{
	irqflags_t flags = cpu_irq_save();
	adc->CTRLA |= ADC_FLUSH_bm;
	cpu_irq_restore(flags);
}

/**
 * \brief rl𒼐ADCɐݒ
 *
 * ADCĂԂ̐v̂߂ɔrl𒼐ADCɐݒ
 *
 * \param adc ADCPʕւ̈ʒuwq
 * \param val Compare value to set, either signed or unsigned.
 *
 * \note ̊֐ɑ΂Ăǂ̌ʂ߂ADCȂ΂Ȃ܂B
 */
#define adc_set_compare_value(adc, val)\
	do {\
		irqflags_t ATPASTE2(adc_flags, __LINE__) =  cpu_irq_save();\
		(adc)->CMP = val;\
		cpu_irq_restore(ATPASTE2(adc_flags, __LINE__));\
	}\
	while (0)

/**
 * \brief ADC璼ڔrl擾
 *
 * ADCĂԂ̐v̂߂ADC璼ڔrl擾܂B
 *
 * \param	adc		ADCPʕւ̈ʒuwq
 *
 * \return	ADČ݂̔rlB̗L͖֌W
 *
 * \note ϸۂ16ޯēǂݍ݂荞݂ی삵܂BϸێsɊ
 * ݂ADCɑ΂16ޯĂ̓ǂݍ݂܂͏݂sȂꍇAǂ
 * ݂̕s邽߂Ɋ荞݂ꎞIɋ֎~Ȃ΂Ȃ܂B
 */
#define adc_get_compare_value(adc)    ((adc)->CMP)

/**
 * \brief ADC璼ڕtrl擾
 *
 * ADCԂ̐v̂߂16ޯēǂݍ݂̊荞ݕیADC璼
 * trl擾܂B
 *
 * \param	adc		ADCPʕւ̈ʒuwq
 */
static inline int16_t adc_get_signed_compare_value(ADC_t *adc)
{
	int16_t val;
	irqflags_t flags;

	flags = cpu_irq_save();
	val = adc->CMP;
	cpu_irq_restore(flags);

	return val;
}

/**
 * \brief ADC璼ڕȂrl擾
 *
 * ADCԂ̐v̂߂16ޯēǂݍ݂̊荞ݕیADC璼
 * Ȃrl擾܂B
 *
 * \param	adc		ADCPʕւ̈ʒuwq
 */
static inline uint16_t adc_get_unsigned_compare_value(ADC_t *adc)
{
	uint16_t val;
	irqflags_t flags;

	flags = cpu_irq_save();
	val = adc->CMP;
	cpu_irq_restore(flags);

	return val;
}

/**
 * \brief Zް擾
 *
 * \param	cal		Zް擾邽߂̎ʎq
 */
static inline uint16_t adc_get_calibration_data(enum adc_calibration_data cal)
{
	uint16_t data;

	switch (cal) {
#ifdef ADCA
	case ADC_CAL_ADCA:
		data = nvm_read_production_signature_row(ADCACAL1);
		data <<= 8;
		data |= nvm_read_production_signature_row(ADCACAL0);
		break;
#endif

#ifdef ADCB
	case ADC_CAL_ADCB:
		data = nvm_read_production_signature_row(ADCBCAL1);
		data <<= 8;
		data |= nvm_read_production_signature_row(ADCBCAL0);
		break;
#endif

#if defined(ADCA) || defined(ADCB)
	case ADC_CAL_TEMPSENSE:
		data = nvm_read_production_signature_row(TEMPSENSE1);
		data <<= 8;
		data |= nvm_read_production_signature_row(TEMPSENSE0);
		break;
#endif

	default:
		Assert(0);
		data = 0;
	}

	return data;
}

/** @} */

/** \name ADCPʕ`Ԑݒ */
/** @{ */

void adc_write_configuration(ADC_t *adc, const struct adc_config *conf);
void adc_read_configuration(ADC_t *adc, struct adc_config *conf);

/**
 * \brief ]޸ۯx𓾂悤ADCOuݒ
 *
 * ̸ۯx_at most_ \a clk_adc_hzɂȂ悤ADCOuݒ肵܂B
 * ͖]ADCۯxɑ΂Ӌ@\ۯx̔䗦vZAł߂Ou
 * Wւ֊ۂ߂邱Ƃɂčs܂B
 *
 * \param	conf		ADCPʕ`Ԑݒւ̈ʒuwq
 * \param	clk_adc		]ADCۯx
 *
 * \note ̎摬x͑SĂ޲ɑ΂ADCۯxPƂɂČ߂܂B
 * ޲ł̓dݒőADC̎摬xɉeyڂ܂Bϊݸ
 * d̏ڍׂȏɂĂ޲̎QƂĂB
 */
static inline void adc_set_clock_rate(struct adc_config *conf, uint32_t clk_adc)
{
	uint32_t clk_per;
	uint16_t ratio;
	uint8_t psc;

	Assert(clk_adc);
#if XMEGA_A || XMEGA_AU
	Assert(clk_adc <= 2000000UL);
#elif XMEGA_B || XMEGA_D
	Assert(clk_adc <= 1400000UL);
#elif XMEGA_C
	Assert(clk_adc <= 1800000UL);
#endif

	clk_per = sysclk_get_per_hz();
	ratio = clk_per / clk_adc;

	/* ł߂OuW֐؂グۂ */
	if (ratio <= 4) {
		psc = ADC_PRESCALER_DIV4_gc;
	} else if (ratio <= 8) {
		psc = ADC_PRESCALER_DIV8_gc;
	} else if (ratio <= 16) {
		psc = ADC_PRESCALER_DIV16_gc;
	} else if (ratio <= 32) {
		psc = ADC_PRESCALER_DIV32_gc;
	} else if (ratio <= 64) {
		psc = ADC_PRESCALER_DIV64_gc;
	} else if (ratio <= 128) {
		psc = ADC_PRESCALER_DIV128_gc;
	} else if (ratio <= 256) {
		psc = ADC_PRESCALER_DIV256_gc;
	} else {
		psc = ADC_PRESCALER_DIV512_gc;
	}

	conf->prescaler = psc;
}

/**
 * \brief ADCϊҰݒ
 *
 * ADCPʕ`Ԑݒł̕ϊɑ΂ĕLA\Adݒ
 *
 * \param	conf	ADCPʕ`Ԑݒւ̈ʒuwq
 * \param	sign	ϊ̗̕L
 * \param	res		ϊ̕\
 * \param	ref		gpd
 */
static inline void adc_set_conversion_parameters(struct adc_config *conf,
		enum adc_sign sign, enum adc_resolution res,
		enum adc_reference ref)
{
	/* ϊƕ\̌`ԐݒSĂۑ */
	conf->ctrlb &= ~(ADC_CONMODE_bm | ADC_RESOLUTION_gm);
	conf->ctrlb |= (uint8_t)res | (uint8_t)sign;

	conf->refctrl &= ~ADC_REFSEL_gm;
	conf->refctrl |= ref;
}

/**
 * \brief ADCϊNݒ
 *
 * ADC̕ϊN`Ԑݒ肵܂B
 *
 * Nɑ΂āA\a nr_of_chŕϊJnِw肳Ȃ΂
 * ܂B̓ɑ΂ّI͑IŁA0ŊJn܂B
 *
 * ۋNɑ΂āA\a base_ev_chŊ{قw肳Ȃ΂Ȃ܂
 * Bق(PNۓ)ۂ\aȂ\aőI`ADCقɑ΂
 * 蓖Ă܂B͎gp꓾ő{قϊJnɑ΂ADC
 * ِ(A\a nr_of_ch)ɂČ߂邱ƂӖ܂B
 *
 * \param	conf		ADCPʕ`Ԑݒւ̈ʒuwq
 * \param	trig		ݒ肷ϊN
 * \param	nr_of_ch	ϊNADCِ:
 *						\arg \c 1 - \c ADC_NR_OF_CHANNELS(0ȊOK{)
 * \param	base_ev_ch	gpȂA{
 */
static inline void adc_set_conversion_trigger(struct adc_config *conf,
		enum adc_trigger trig, uint8_t nr_of_ch, uint8_t base_ev_ch)
{
	Assert(nr_of_ch);
	Assert(nr_of_ch <= ADC_NR_OF_CHANNELS);
#if XMEGA_A || XMEGA_AU
	Assert(base_ev_ch <= 7);
#elif XMEGA_B || XMEGA_C || XMEGA_D
	Assert(base_ev_ch <= 3);
#endif

	switch (trig) {
	case ADC_TRIG_MANUAL:
		conf->ctrlb &= ~ADC_FREERUN_bm;
		conf->evctrl = ADC_EVACT_NONE_gc;
		break;

	case ADC_TRIG_EVENT_SINGLE:
		conf->ctrlb &= ~ADC_FREERUN_bm;
		conf->evctrl = (base_ev_ch << ADC_EVSEL_gp) |
				(nr_of_ch << ADC_EVACT_gp);
		break;

#if ADC_NR_OF_CHANNELS > 1
	case ADC_TRIG_FREERUN_SWEEP:
		conf->ctrlb |= ADC_FREERUN_bm;
		conf->evctrl = (nr_of_ch - 1) << ADC_SWEEP_gp;
		break;

	case ADC_TRIG_EVENT_SWEEP:
		conf->ctrlb &= ~ADC_FREERUN_bm;
		conf->evctrl = (nr_of_ch - 1) << ADC_SWEEP_gp |
				(base_ev_ch << ADC_EVSEL_gp) |
				ADC_EVACT_SWEEP_gc;
		break;
#endif
#if XMEGA_A || (CONFIG_ADC_VERSION == 2)
	case ADC_TRIG_EVENT_SYNCSWEEP:
		conf->ctrlb &= ~ADC_FREERUN_bm;
		conf->evctrl =
#  if ADC_NR_OF_CHANNELS > 1
				((nr_of_ch - 1) << ADC_SWEEP_gp) |
#  endif
				(base_ev_ch << ADC_EVSEL_gp) |
				ADC_EVACT_SYNCHSWEEP_tmpfix_gc;
		break;
#endif

	default:
		Assert(0);
	}
}

#if ADC_NR_OF_CHANNELS > 1

/**
 * \brief DMAvQݒ
 *
 * w肳ꂽADCِɑ΂DMAQv`Ԑݒ肵܂BٌQI͑I
 * ŁA0ŊJn܂B
 *
 * \param	conf		ADCPʕ`Ԑݒւ̈ʒuwq
 * \param	nr_of_ch	Qvɑ΂ِ:
 *						֎~ɂ\arg 0Aɂ\arg 2,3,܂4
 *
 * \note DMAvQłِ1ɂł܂B
 * \note SĂ޲n̐ݒƂł͂܂B
 */
static inline void adc_set_dma_request_group(struct adc_config *conf,
		uint8_t nr_of_ch)
{
	Assert(nr_of_ch <= ADC_NR_OF_CHANNELS);
	Assert(nr_of_ch != 1);

	if (nr_of_ch) {
		conf->ctrla = (nr_of_ch - 1) << ADC_DMASEL_gp;
	} else {
		conf->ctrla = ADC_DMASEL_OFF_gc;
	}
}

#endif

/**
 * \brief ADC͂
 *
 * \param	conf		ADCPʕ`Ԑݒւ̈ʒuwq
 * \param	int_inp		:
 *						xmɑ΂\arg \c ADC_INT_TEMPSENSE
 *						޷ެߊdɑ΂\arg \c ADC_INT_BANDGAP
 */
static inline void adc_enable_internal_input(struct adc_config *conf,
		uint8_t int_inp)
{
	conf->refctrl |= int_inp;
}

/**
 * \brief ADC͂֎~
 *
 * \param	conf		ADCPʕ`Ԑݒւ̈ʒuwq
 * \param	int_inp		֎~:
 *						xmɑ΂\arg \c ADC_INT_TEMPSENSE
 *						޷ެߊdɑ΂\arg \c ADC_INT_BANDGAP
 */
static inline void adc_disable_internal_input(struct adc_config *conf,
		uint8_t int_inp)
{
	conf->refctrl &= ~int_inp;
}

#if XMEGA_AU || defined(__DOXYGEN__)
/** \brief ADCi߰ݽݒ */
enum adc_gainstage_impmode {
	ADC_GAIN_HIGHIMPEDANCE,	/**< ߰ݽ */
	ADC_GAIN_LOWIMPEDANCE,	/**< ߰ݽ */
};

/**
 * \brief ADCi߰ݽ
 *
 * \param	conf	ADCPʕ`Ԑݒւ̈ʒuwq
 * \param	mode	i߰ݽ
 *
 * \note SĂ޲n̐ݒƂł͂܂B
 */
static inline void adc_set_gain_impedance_mode(struct adc_config *conf,
		enum adc_gainstage_impmode impmode)
{
	switch (impmode) {
	case ADC_GAIN_HIGHIMPEDANCE:
		conf->ctrlb &= ~ADC_IMPMODE_bm;
		break;

	case ADC_GAIN_LOWIMPEDANCE:
		conf->ctrlb |= ADC_IMPMODE_bm;
		break;

	default:
		Assert(0);
	}
}

#endif

#if CONFIG_ADC_VERSION == 2
/** \brief ADCdݒ */
enum adc_current_limit {
	ADC_CURRENT_LIMIT_NO,	/**< dȂ */
	ADC_CURRENT_LIMIT_LOW,	/**< dAő̎摬x1.5Msps */
	ADC_CURRENT_LIMIT_MED,	/**< dAő̎摬x1Msps */
	ADC_CURRENT_LIMIT_HIGH	/**< dAő̎摬x0.5Msps */
};

/**
 * \brief ADCdݒ
 *
 * ADCPʕɓdݒB̐ݒADC̍ő̎摬xɉeyڂ
 * B
 *
 * \note dƍ̎摬xɂĂ̏ڍׂȏɊւĂ޲ްĂ
 * QƂĂB
 *
 * \param	conf		ADCPʕ`Ԑݒւ̈ʒuwq
 * \param	currlimit	dݒ
 *
 * \note SĂ޲n̐ݒƂł͂܂B
 */
static inline void adc_set_current_limit(struct adc_config *conf,
		enum adc_current_limit currlimit)
{
	conf->ctrlb &= ~ADC_CURRLIMIT_tmpfix_gm;

	switch (currlimit) {
	case ADC_CURRENT_LIMIT_NO:
		conf->ctrlb |= ADC_CURRLIMIT_NO_tmpfix_gc;
		break;

	case ADC_CURRENT_LIMIT_LOW:
		conf->ctrlb |= ADC_CURRLIMIT_SMALL_tmpfix_gc;
		break;

	case ADC_CURRENT_LIMIT_MED:
		conf->ctrlb |= ADC_CURRLIMIT_MEDIUM_tmpfix_gc;
		break;

	case ADC_CURRENT_LIMIT_HIGH:
		conf->ctrlb |= ADC_CURRLIMIT_LARGE_tmpfix_gc;
		break;

	default:
		Assert(0);
	}
}

#endif

/**
 * \brief `ԐݒADCrlݒ
 *
 * \param	conf	ADCPʕ`Ԑݒւ̈ʒuwq
 * \param	val		ݒ肷rl
 */
#define adc_set_config_compare_value(conf, val)\
	do {\
		conf->cmp = (uint16_t)val;\
	}\
	while (0)

/**
 * \brief `Ԑݒ肩ADCrl擾
 *
 * \param	conf	ADCPʕ`Ԑݒւ̈ʒuwq
 */
#define adc_get_config_compare_value(conf)    (conf->cmp)

/** @} */

/** @} */

/**
 * \defgroup adc_channel_group ADC
 *
 * ADCقɑ΂Ǘƌ`Ԑݒ̊֐
 *
 * API̊֐ƒ`͎2̌Qɕ邱Ƃł܂B:
 * - يǗ: ϊʂ𓾂邽߂̒ڱ
 * - ٌ`Ԑݒ: ADCقɑ΂`Ԑݒ̍쐬/ύXƂ̓ǂݏ
 *
 * @{
 */

/**
 * \brief ADCي荞
 *
 * \note ي荞ق㏑ɂ\ref conf_adc.hŖ]قƂĂ̼
 * ق`ĂB.
 */
#if !defined(CONFIG_ADC_INTLVL) || defined(__DOXYGEN__)
#  define CONFIG_ADC_INTLVL    ADC_CH_INTLVL_LO_gc
#endif

/** ADCٌ`Ԑݒ */
struct adc_channel_config {
	uint8_t ctrl;
	uint8_t muxctrl;
	uint8_t intctrl;
#if CONFIG_ADC_VERSION == 2
	uint8_t scan;
#endif
};

/**
 * \brief ADCِ
 *
 * ADCقւ̐͂ƂĎgp邱ƂłOƓ̓͂
 *
 * \note ޲͑߰Ăł݂gp邱Ƃł܂Bp\
 * ADC͐Ƃ݂ւ̊蓖Ă̏ɂĂ޲ްĂQƂ
 * B
 */
enum adcch_positive_input {
	ADCCH_POS_PIN0,
	ADCCH_POS_PIN1,
	ADCCH_POS_PIN2,
	ADCCH_POS_PIN3,
	ADCCH_POS_PIN4,
	ADCCH_POS_PIN5,
	ADCCH_POS_PIN6,
	ADCCH_POS_PIN7,

	/** \name ߰Ăł̓ */
	/** @{ */
#if XMEGA_A3U || XMEGA_A4 || XMEGA_A4U || XMEGA_B\
	|| XMEGA_C || XMEGA_D || defined(__DOXYGEN__)
	/* A3U,A4,A4U,B,C,DADC8:11݂łB */
	ADCCH_POS_PIN8,
	ADCCH_POS_PIN9,
	ADCCH_POS_PIN10,
	ADCCH_POS_PIN11,
#endif
#if XMEGA_A3U || XMEGA_B || XMEGA_C || XMEGA_D3 || defined(__DOXYGEN__)
	/* A3U,B,C,D3ADC12:15݂łB */
	ADCCH_POS_PIN12,
	ADCCH_POS_PIN13,
	ADCCH_POS_PIN14,
	ADCCH_POS_PIN15,
#endif
	/** @} */

	/** \name  */
	/** @{ */
	ADCCH_POS_TEMPSENSE,	/**< xm */
	ADCCH_POS_BANDGAP,		/**< ޷ެߊd */
	ADCCH_POS_SCALED_VCC,	/**< VCC/10 */
#if XMEGA_A || XMEGA_AU || defined(__DOXYGEN__)
	ADCCH_POS_DAC,			/**< DACo */
#endif
	/** @} */
};

/**
 * \brief ADCٕ
 *
 * ADCقɑ΂ĕ͂ƂĎgp邱ƂłMʁB͐M
 * ̂͈闘ݒAႦ΁A1{łp\łB
 *
 * \note ADC͍gp̂ɕtŐݒ肳Ȃ΂Ȃ܂B
 *  ޑɂĂ͕͂ƂADDCH_NEG_NONEw肳ׂłB
 *
 * \note SĂ޲߯ނƓGND͗psłBp\ȓ͐M̊Tv
 * Ă޲̎B
 */
enum adcch_negative_input {
	/** \name 1{ł̍p */
	/** @{ */
	ADCCH_NEG_PIN0,				/**< ADC0 */
	ADCCH_NEG_PIN1,				/**< ADC1 */
	ADCCH_NEG_PIN2,				/**< ADC2 */
	ADCCH_NEG_PIN3,				/**< ADC3 */
	/** @} */

	/** \name ꂩ̗ł̍p */
	/** @{ */
	ADCCH_NEG_PIN4,				/**< ADC4 */
	ADCCH_NEG_PIN5,				/**< ADC5 */
	ADCCH_NEG_PIN6,				/**< ADC6 */
	ADCCH_NEG_PIN7,				/**< ADC7 */
	/**< @} */

#if CONFIG_ADC_VERSION == 2
	/** \name pGNDM */
	/** @{ */
	ADCCH_NEG_PAD_GND,			/**< PADڒn */
	ADCCH_NEG_INTERNAL_GND,		/**< ڒn */
	/** @} */
#endif

	ADCCH_NEG_NONE,				/**< ݸ ޓ */
};

/** \brief ADCي荞ݓ` */
enum adcch_mode {
	ADCCH_MODE_COMPLETE = ADC_CH_INTMODE_COMPLETE_gc,	/**< ϊɊ荞׸ސݒ */
	ADCCH_MODE_BELOW    = ADC_CH_INTMODE_BELOW_gc,		/**< ϊʂrlȉ̎Ɋ荞׸ސݒ */
	ADCCH_MODE_ABOVE    = ADC_CH_INTMODE_ABOVE_gc,		/**< ϊʂrlȏ̎Ɋ荞׸ސݒ */
};

/** \name ADCٌ`Ԑݒ */
/** @{ */

void adcch_write_configuration(ADC_t *adc, uint8_t ch_mask,
		const struct adc_channel_config *ch_conf);
void adcch_read_configuration(ADC_t *adc, uint8_t ch_mask,
		struct adc_channel_config *ch_conf);

/** 1ł̗i */
#define ADCCH_FORCE_1X_GAINSTAGE	0xff

/**
 * \internal
 * \brief w肵ɑ΂ADCِݒ擾
 *
 * w肵ɑΉݒԂ܂B
 *
 * \param	gain	ɑ΂ėLȗW
 *
 * \return	Gain	ADC_CH_GAIN_t^̐ݒ
 */
static inline uint8_t adcch_get_gain_setting(uint8_t gain)
{
	switch (gain) {
#if (CONFIG_ADC_VERSION == 2) || XMEGA_D
	case 0:
		return ADC_CH_GAIN_DIV2_tmpfix_gc;
#endif
	case 1:
		return ADC_CH_GAIN_1X_gc;

	case 2:
		return ADC_CH_GAIN_2X_gc;

	case 4:
		return ADC_CH_GAIN_4X_gc;

	case 8:
		return ADC_CH_GAIN_8X_gc;

	case 16:
		return ADC_CH_GAIN_16X_gc;

	case 32:
		return ADC_CH_GAIN_32X_gc;

	case 64:
		return ADC_CH_GAIN_64X_gc;

	case ADCCH_FORCE_1X_GAINSTAGE:
		return ADC_CH_GAIN_1X_gc;

	default:
		Assert(0);
		return 0;
	}
}

/**
 * \brief ADC͓ٓAdAݒ
 *
 * ADCق͓̓Ǝw肵͐Mɏ]dłȂAݒ肵
 * B
 *
 * \param	ch_conf		ADCٌ`Ԑݒւ̈ʒuwq
 * \param	pos			͐M
 * \param	neg			͐M:
 *						ݸ ޑɑ΂\arg \c ADCCH_NEG_NONEB
 *						ɑ΂\arg \c ADCCH_NEG_PINnA\c n
 *						wB
 *						ɑ΂\arg \c ADDCH_x_GNDA\c x߯
 *						܂͓GNDw
 * \param	gain		pW
 *						ݸ ނ܂͕͂ƂĂ0,1,2,3A߯ނ܂͓
 *						GNDł̍ɑ΂\arg 1B
 *						͂ƂĂ4,5,6,7A߯ނ܂͓GNDł̍
 *						΂\arg 0(0.5x),1,2,4,8,16,32,܂64B
 *						ɑ΂ė1ł̋𗘓iɋɂ
 *						\arg ADCCH_FORCE_1X_GAINSTAGEB
 *
 * \note 0ɐݒ肷邱ƂɂđI΂0.5xW͑SĂ޲ŗp
 * \ł͂܂Bp\ȗW̏ɂĂ޲̎QƂ
 * ĂB
 *
 * \note GNDM͑SĂ޲ŗp\ł͂܂Bp\ȓ͐M̏
 * ɂĂ޲̎QƂĂB
 *
 * \note 1(1x)ŁA̓͑I͗i̗L̗ŉ\
 * ܂Bײނ͎gp҂\a gainƂ\ref ADCCH_FORCE_1X_GAINSTAGEw肵
 * A\ȌႢdۂ߂ɗiȂł̌`Ԑݒɂ
 * B
 */
static inline void adcch_set_input(struct adc_channel_config *ch_conf,
		enum adcch_positive_input pos, enum adcch_negative_input neg,
		uint8_t gain)
{
#if (CONFIG_ADC_VERSION == 2) || XMEGA_D
	/* AU,B,D޲ł0̗l1/2łB */
#else
	/* 0͑޲ŗps */
	Assert(gain);
#endif

	/* ͗p`Ԑݒ */
	if (pos >= ADCCH_POS_TEMPSENSE) {
		Assert(gain == 1);
		Assert(neg == ADCCH_NEG_NONE);

		ch_conf->ctrl = ADC_CH_INPUTMODE_INTERNAL_gc;
		ch_conf->muxctrl = (pos - ADCCH_POS_TEMPSENSE) <<
				ADC_CH_MUXPOS_gp;
		return;
	}

	/* ݸ ޑp`Ԑݒ */
	if (neg == ADCCH_NEG_NONE) {
		Assert(gain == 1);

		ch_conf->ctrl = ADC_CH_INPUTMODE_SINGLEENDED_gc;
		ch_conf->muxctrl = pos << ADC_CH_MUXPOS_gp;

		/* p`Ԑݒ */
	} else {
		/* igpȂAA1{̏ꍇ0`3݂͂Ɏgp
		 * 邱Ƃł܂B
		 */
		if (neg <= ADCCH_NEG_PIN3) {
			Assert(gain == 1);

			ch_conf->ctrl = ADC_CH_INPUTMODE_DIFF_gc;
			ch_conf->muxctrl = (pos << ADC_CH_MUXPOS_gp) |
					(neg << ADC_CH_MUXNEG_gp);
		} else if (neg <= ADCCH_NEG_PIN7) {
			/* 4`7݂͗Ⴆiłp\1{܂ޑSĂ̗
			 * Ɏgp邱Ƃł܂B
			 */
			ch_conf->ctrl = ADC_CH_INPUTMODE_DIFFWGAIN_gc |
					adcch_get_gain_setting(gain);
			ch_conf->muxctrl = (pos << ADC_CH_MUXPOS_gp) |
					((neg - ADCCH_NEG_PIN4) <<
					ADC_CH_MUXNEG_gp);
		}

#if CONFIG_ADC_VERSION == 2
		else {
			/* ߏGNDMɑ΂ޯĎՕ͗ꂽɕς܂B
			 * svȓd邽߁AADCCH_FORCE_1X_GAINSTAGEϸۂŎgp
			 * Iɂw肵ȂA1{ɑ΂ėi
			 * łB
			 */
			if (gain == 1) {
				ch_conf->ctrl = ADC_CH_INPUTMODE_DIFF_gc;
				neg = (neg == ADCCH_NEG_PAD_GND) ?
						ADCCH_NEG_PIN5 : ADCCH_NEG_PIN7;
                                                
			} else {
				ch_conf->ctrl = ADC_CH_INPUTMODE_DIFFWGAIN_gc |
						adcch_get_gain_setting(gain);
				neg = (neg == ADCCH_NEG_INTERNAL_GND) ?
						ADCCH_NEG_PIN4 : ADCCH_NEG_PIN7;
			}

			ch_conf->muxctrl = (pos << ADC_CH_MUXPOS_gp) |
					(neg << ADC_CH_MUXNEG_gp);
		}
#endif
	}
}

#if CONFIG_ADC_VERSION == 2

/**
 * \brief ADC0ݑݒ
 *
 * ϊԂłǂȍČ`ԐݒȂɕ̘Ȃ݂ݑp
 * ҰݒB
 *
 * ݑ݂݂͌̓𓾂邽߂ɐMUXݒɕψʂǉ邱Ƃɂē
 * ܂Bψʂ͊eϊɑAőψʂϊUI0ؾĂ
 * ܂B
 *
 * \param	start_offset	\arg \c 0 - \c max_offsetݑJn鏉ψ
 * \param	max_offset		ݑɑ΂őψ:
 *							֎~ɂ\arg \c 0Aɂ\arg \c 1 - \c 15
 *
 * \note AVR XMEGA AUn̐ݒŋ@\܂B
 * \note ݑADCOłp\łB
 */
static inline void adcch_set_pin_scan(struct adc_channel_config *ch_conf,
		uint8_t start_offset, uint8_t max_offset)
{
	Assert(start_offset < 16);
	Assert(max_offset < 16);
	Assert(start_offset <= max_offset);

	ch_conf->scan = max_offset | (start_offset << ADC_CH_OFFSET_gp);
}

#endif

/**
 * \brief ADCي荞ݓ`Ԑݒ
 *
 * \param	ch_conf		ADCٌ`Ԑݒւ̈ʒuwq
 * \param	mode		ݒ肷銄荞ݓ`
 */
static inline void adcch_set_interrupt_mode(struct adc_channel_config *ch_conf,
		enum adcch_mode mode)
{
	ch_conf->intctrl &= ~ADC_CH_INTMODE_gm;
	ch_conf->intctrl |= mode;
}

/**
 * \brief ADCقł̊荞݂
 *
 * \param	ch_conf		ADCٌ`Ԑݒւ̈ʒuwq
 */
static inline void adcch_enable_interrupt(struct adc_channel_config *ch_conf)
{
	ch_conf->intctrl &= ~ADC_CH_INTLVL_gm;
	ch_conf->intctrl |= CONFIG_ADC_INTLVL;
}

/**
 * \brief ADCقł̊荞݂֎~
 *
 * \param	ch_conf		ADCٌ`Ԑݒւ̈ʒuwq
 */
static inline void adcch_disable_interrupt(struct adc_channel_config *ch_conf)
{
	ch_conf->intctrl &= ~ADC_CH_INTLVL_gm;
	ch_conf->intctrl |= ADC_CH_INTLVL_OFF_gc;
}

/** @} */

/** @} */

/** @} */

#ifdef __cplusplus
}
#endif

#endif /* ADC_H */
