/**
 * \file
 *
 * \brief AVR XMEGApUSARTײ
 *
 * ̧ق͑SĂ̓AݒAۯxAVR XMEGA USARTp̊{֐܂݂܂B
 *
 * 쌠 (c) 2009-2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef _USART_H_
#define _USART_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "compiler.h"
#include "pmic.h"

/**
 * \defgroup usart_group USARTPʕ(USART)
 *
 * \ref xmega_usart_quickstartB
 *
 * ߏUSARŤ`ԐݒAA֎~Agp̂߂ײނłB
 *
 * \section dependencies ˑ
 *
 * USARTPʕ͈ȉ̒PʕɈˑ܂B:
 *  - Ӌ@\ۯp\ref sysclk_group
 *  - Ӌ@\I/O߰Đp\ref port_driver_group
 *
 * @{
 */

#define USART_BAUD_1200			0x00	//!< ްڰ1200ɑ΂Qƕ\ł̕ψ
#define USART_BAUD_2400			0x01	//!< ްڰ2400ɑ΂Qƕ\ł̕ψ
#define USART_BAUD_4800			0x02	//!< ްڰ4800ɑ΂Qƕ\ł̕ψ
#define USART_BAUD_9600			0x03	//!< ްڰ9600ɑ΂Qƕ\ł̕ψ
#define USART_BAUD_19200		0x04	//!< ްڰ19200ɑ΂Qƕ\ł̕ψ
#define USART_BAUD_38400		0x05	//!< ްڰ38400ɑ΂Qƕ\ł̕ψ
#define USART_BAUD_57600		0x06	//!< ްڰ57600ɑ΂Qƕ\ł̕ψ
#define USART_BAUD_UNDEFINED	0xFF	//!< Qƕ\ɂȂްڰ

//! 2MHzCPUgɑ΂BAUDCTRLl܂ގQƕ\
static PROGMEM_DECLARE(uint16_t, baudctrl_2mhz[]) = {
	0xE5BC,		// ްڰ: 1200
	0xC5AC,		// ްڰ: 2400
	0x859C,		// ްڰ: 4800
	0x0396,		// ްڰ: 9600
	0xC192,		// ްڰ: 19200
	0x2191,		// ްڰ: 38400
	0x9690,		// ްڰ: 57600
};

//! 32MHzCPUgɑ΂BAUDCTRLl܂ގQƕ\
static PROGMEM_DECLARE(uint16_t, baudctrl_32mhz[]) = {
	0x031D,		// ްڰ: 1200
	0x01ED,		// ްڰ: 2400
	0xFDDC,		// ްڰ: 4800
	0xF5CC,		// ްڰ: 9600
	0xE5BC,		// ްڰ: 19200
	0xC5AC,		// ްڰ: 38400
	0x6EA8,		// ްڰ: 57600
};
//! @}

//! RS232Ɠl鎞̓Ұ
typedef struct usart_rs232_options {
	//! USARTްڰĐݒ(]uŕsgp)
	uint32_t baudrate;

	//! ƂđޯĐ(5`9)
	USART_CHSIZE_t charlength;

	//! è`: USART_PMODE_DISABLED_gc, USART_PMODE_EVEN_gc,
	//! USART_PMODE_ODD_gc.
	USART_PMODE_t paritytype;

	//! 2Ԃ̒~ޯĐ:
	//! true: 2~ޯ
	//! false: 1~ޯ
	bool stopbits;

} usart_rs232_options_t;

//! SPI呕u鎞̓Ұ
typedef struct usart_spi_options {
	//! SPIłUSARTްڰĂݒ
	uint32_t baudrate;

	//! SPIM
	uint8_t spimode;

	uint8_t data_order;
} usart_spi_options_t;

//! USART荞
enum usart_int_level_t {
	USART_INT_LVL_OFF = 0x00,
	USART_INT_LVL_LO = 0x01,
	USART_INT_LVL_MED = 0x02,
	USART_INT_LVL_HI = 0x03,
};

/**
 * \brief USARTM
 *
 * \param	usart	USARTPʕւ̈ʒuwq
 */
static inline void usart_rx_enable(USART_t *usart)
{
	(usart)->CTRLB |= USART_RXEN_bm;
}

/**
 * \brief USARTM֎~
 *
 * \param	usart	USARTPʕւ̈ʒuwq
 */
static inline void usart_rx_disable(USART_t *usart)
{
	(usart)->CTRLB &= ~USART_RXEN_bm;
}

/**
 * \brief USARTڰь``Ԑݒ
 *
 * ڰь`Aڰт̑傫AèA~ޯĐݒ
 *
 * \param	usart			USARTPʕւ̈ʒuwq
 * \param	charSize		̑傫BUSART_CHSIZE_t^gpĂB
 * \param	parityMode		èBUSART_PMODE_t^gpĂB
 * \param	twoStopBits		2~ޯē싖Aްٌ^gpĂB
 */
static inline void usart_format_set(USART_t *usart, USART_CHSIZE_t charSize,
		USART_PMODE_t parityMode, bool twoStopBits)
{
	(usart)->CTRLC = (uint8_t)charSize | parityMode
		| (twoStopBits ? USART_SBMODE_bm : 0);
}

/**
 * \brief USARTM
 *
 * \param	usart	USARTPʕւ̈ʒuwq
 */
static inline void usart_tx_enable(USART_t *usart)
{
	(usart)->CTRLB |= USART_TXEN_bm;
}

/**
 * \brief USARTM֎~
 *
 * \param	usart	USARTPʕւ̈ʒuwq
 */
static inline void usart_tx_disable(USART_t *usart)
{
	(usart)->CTRLB &= ~USART_TXEN_bm;
}

/**
 * \brief	USART RXD荞ِݒ
 *
 * M荞݂̊荞قݒ
 *
 * \param	usart	USARTPʕւ̈ʒuwq
 * \param	level	M荞݂̊荞
 */
static inline void usart_set_rx_interrupt_level(USART_t *usart,
		enum usart_int_level_t level)
{
	(usart)->CTRLA = ((usart)->CTRLA & ~USART_RXCINTLVL_gm) |
			(level << USART_RXCINTLVL_gp);
}

/**
 * \brief USARTM荞ِݒ
 *
 * M荞݂̊荞قݒ
 *
 * \param	usart	USARTPʕւ̈ʒuwq
 * \param	level	M荞݂̊荞
 */
static inline void usart_set_tx_interrupt_level(USART_t *usart,
		enum usart_int_level_t level)
{
	(usart)->CTRLA = ((usart)->CTRLA & ~USART_TXCINTLVL_gm) |
			(level << USART_TXCINTLVL_gp);
}

/**
 * \brief USART DRE荞ِݒ
 *
 * ް ڼ޽荞݂̊荞قݒ
 *
 * \param	usart	USARTPʕւ̈ʒuwq
 * \param	level	DRE荞݂̊荞
 *					USART_DREINTLVL_t^gpĂB
 */
static inline void usart_set_dre_interrupt_level(USART_t *usart,
		enum usart_int_level_t level)
{
	(usart)->CTRLA = ((usart)->CTRLA & ~USART_DREINTLVL_gm) |
			(level << USART_DREINTLVL_gp);
}

/**
 * \brief USARTs`Ԑݒ
 *
 * USARTs`ԂݒB`Ԃ͔񓯊łB
 *
 * \param	usart		USARTPʕڼ޽̈ւ̈ʒuwq
 * \param	usartmode	USART`ԑIAUSART_CMODE_t^gpĂB
 *
 * USART`:
 * - 0x0 : 񓯊
 * - 0x1 : 
 * - 0x2 : IrDA
 * - 0x3 : 呕uSPI
 */
static inline void usart_set_mode(USART_t *usart, USART_CMODE_t usartmode)
{
	(usart)->CTRLC = ((usart)->CTRLC & (~USART_CMODE_gm)) | usartmode;
}

/**
 * \brief ް ڼ޽׸ނݒ肩
 *
 * \param	usart	USARTPʕ
 */
static inline bool usart_data_register_is_empty(USART_t * usart)
{
	return (usart)->STATUS & USART_DREIF_bm;
}

/**
 * \brief M荞׸ނݒ肩
 *
 * M荞׸ނݒ肩܂B
 *
 * \param	usart	USARTPʕ
 */
static inline bool usart_rx_is_complete(USART_t * usart)
{
	return (usart)->STATUS & USART_RXCIF_bm;
}

/**
 * \brief M荞׸ނݒ肩
 *
 * M荞׸ނݒ肩܂B
 *
 * \param	usart	USARTPʕ
 */
static inline bool usart_tx_is_complete(USART_t * usart)
{
	return (usart)->STATUS & USART_TXCIF_bm;
}

/**
 * \brief M荞׸މ
 *
 * \param	usart	USARTPʕ
 */
static inline void usart_clear_tx_complete(USART_t * usart)
{
	(usart)->STATUS = USART_TXCIF_bm;
}

/**
 * \brief M荞׸މ
 *
 * \param	usart	USARTPʕ
 */
static inline void usart_clear_rx_complete(USART_t *usart)
{
	(usart)->STATUS = USART_RXCIF_bm;
}

/**
 * \brief USARTް ڼ޽ް
 *
 * \param	usart	USARTPʕ
 * \param	txdata	ׂް
 */
static inline void usart_put(USART_t * usart, uint8_t txdata)
{
	(usart)->DATA = txdata;
}

/**
 * \brief USARTް ڼ޽ްǂݍ
 *
 * \param	usart	USARTPʕ
 *
 * \return Mް
 */
static inline uint8_t usart_get(USART_t * usart)
{
	return (usart)->DATA;
}

/**
 * \brief SPIUSARTłް]s
 *
 * \param	usart	USARTPʕ
 * \param	txdata	ׂް
 *
 * \return Mް
 */
static inline uint8_t usart_spi_transmit(USART_t * usart,
		uint8_t txdata)
{
	while (usart_data_register_is_empty(usart) == false);
	usart_put(usart, txdata);
	while (!usart_tx_is_complete(usart));
	usart_clear_tx_complete(usart);
	return usart_get(usart);
}

bool usart_init_rs232(USART_t *usart, const usart_rs232_options_t *opt);
void usart_init_spi(USART_t * usart, const usart_spi_options_t * opt);

enum status_code usart_putchar(USART_t * usart, uint8_t c);
uint8_t usart_getchar(USART_t * usart);

void usart_set_bsel_bscale_value(USART_t *usart, uint16_t bsel, uint8_t bscale);
void usart_set_baudrate_precalculated(USART_t *usart, uint32_t baud,
		uint32_t cpu_hz);
bool usart_set_baudrate(USART_t *usart, uint32_t baud, uint32_t cpu_hz);
void usart_spi_set_baudrate(USART_t * usart, uint32_t baud, uint32_t cpu_hz);
//! @}

#ifdef __cplusplus
}
#endif

/**
 * \page xmega_usart_quickstart USARTPʕpJn̎
 *
 * ͎gpʂ̑Iײނ̌`ԐݒƎgp̕@̒iKIwł
 * \ref usart_group "USARTPʕ"pJn̎łB
 *
 * gpʂ͂̺ޒfЂ܂݂܂B̒iKł̺ޒfЂ͓Ǝ
 * ɕʂ邱ƂłAŎg̒iK͗Ⴆ΁A剞p֐ɕʂ邱
 * ł܂B
 *
 * \section usart_basic_use_case {IȎgp
 * \section usart_use_cases USARTgp
 * - \ref usart_basic_use_case
 * - \subpage usart_use_case_1
 *
 * \section usart_basic_use_case {IȎgp - M
 * ̎gpʂłUSARTPʕ̗lɌ`Ԑݒ肳܂B:
 * - USARTD0gp
 * - ްڰ: 9600
 * - : 8ޯ
 * - è: ֎~
 * - ~ޯ: 1
 * - RS232
 *
 * \section usart_basic_use_case_setup iK
 *
 * \subsection usart_basic_use_case_setup_prereq OKv
 * -# \ref sysclk_group
 * \subsection usart_basic_use_case_setup_code ޗ
 * ȉ̌`Ԑݒ肪ۼުĂɒǉȂ΂Ȃ܂(ʓIconf_usart.ḩ
 * قɂłA剞p̧قɒǉ邱Ƃł܂B)
 * \code
 *    #define USART_SERIAL                     &USARTD0
 *    #define USART_SERIAL_BAUDRATE            9600
 *    #define USART_SERIAL_CHAR_LENGTH         USART_CHSIZE_8BIT_gc
 *    #define USART_SERIAL_PARITY              USART_PMODE_DISABLED_gc
 *    #define USART_SERIAL_STOP_BIT            false
 * \endcode
 *
 * pɒǉ܂B:
 * \code
 *    sysclk_init();
 *    static usart_rs232_options_t USART_SERIAL_OPTIONS = {
 *       .baudrate = USART_SERIAL_BAUDRATE,
 *       .charlength = USART_SERIAL_CHAR_LENGTH,
 *       .paritytype = USART_SERIAL_PARITY,
 *       .stopbits = USART_SERIAL_STOP_BIT
 *    };
 *   sysclk_enable_module(SYSCLK_PORT_D, PR_USART0_bm);
 *   usart_init_rs232(USART_SERIAL, &USART_SERIAL_OPTIONS);
 * \endcode
 *
 * \subsection usart_basic_use_case_setup_flow Ƃ̗
 * -#  ۯ:
 *   - \code sysclk_init(); \endcode
 *   - \note Not always required, but since the \ref usart_group driver is 
 *           dependent on \ref sysclk_group it is good practise to initialize
 *           this module. 
 * -# USARTCӑI\̂쐬:
 *   - \code
 *       static usart_rs232_options_t USART_SERIAL_OPTIONS = {
 *          .baudrate = USART_SERIAL_BAUDRATE,
 *          .charlength = USART_SERIAL_CHAR_LENGTH,
 *          .paritytype = USART_SERIAL_PARITY,
 *          .stopbits = USART_SERIAL_STOP_BIT
 *       };
 *     \endcode
 * -# USARTPʕpۯ:
 *   - \code sysclk_enable_module(SYSCLK_PORT_D, PR_USART0_bm); \endcode
 * -# RS232ŏ:
 *   - \code usart_init_rs232(USART_SERIAL, &USART_SERIAL_OPTIONS);
 *     \endcode
 *
 * \section usart_basic_use_case_usage g
 *
 * \subsection usart_basic_use_case_usage_code ޗ
 * pÇقɒǉ܂B:
 * \code
 *    usart_putchar(USART_SERIAL, 'a');
 * \endcode
 *
 * \subsection usart_basic_use_case_usage_flow Ƃ̗
 * -# Send an 'a' character via USART
 *   - \code usart_putchar(USART_SERIAL, 'a'); \endcode
 */

/**
 * \page usart_use_case_1 USARTMƑԂ
 *
 * ̎gpʂłUSARTPʕ̗lɌ`Ԑݒ肳܂B:
 * - USARTD0gp
 * - ްڰ: 9600
 * - : 8ޯ
 * - è: ֎~
 * - ~ޯ: 1
 * - RS232
 *
 * gpʂ͌`Ԑݒ肵USARTŎM҂ĕ𓯂USARTɑԂ
 * B
 *
 * \section usart_use_case_1_setup iK
 *
 * \subsection usart_use_case_1_setup_prereq OKv
 * -# \ref sysclk_group
 *
 * \subsection usart_use_case_1_setup_code ޗ
 * -# ȉ̌`Ԑݒ肪ۼުĂɒǉȂ΂Ȃ܂(ʓIconf_usart.h
 * ̧قɂłAȂ̎剞p̧قɒǉ邱Ƃł܂)B:
 * \code
 *    #define USART_SERIAL                     &USARTD0
 *    #define USART_SERIAL_BAUDRATE            9600
 *    #define USART_SERIAL_CHAR_LENGTH         USART_CHSIZE_8BIT_gc
 *    #define USART_SERIAL_PARITY              USART_PMODE_DISABLED_gc
 *    #define USART_SERIAL_STOP_BIT            false
 * \endcode
 *
 * M޲ėp̕ϐǉȂ΂Ȃ܂B:
 * \code uint8_t received_byte; \endcode
 *
 * pɒǉ܂B:
 * \code
 *    sysclk_init();
 *    static usart_rs232_options_t USART_SERIAL_OPTIONS = {
 *       .baudrate = USART_SERIAL_BAUDRATE,
 *       .charlength = USART_SERIAL_CHAR_LENGTH,
 *       .paritytype = USART_SERIAL_PARITY,
 *       .stopbits = USART_SERIAL_STOP_BIT
 *    };
 *   sysclk_enable_module(SYSCLK_PORT_D, PR_USART0_bm);
 *   usart_init_rs232(USART_SERIAL, &USART_SERIAL_OPTIONS);
 * \endcode
 *
 * \subsection usart_use_case_1_setup_flow Ƃ̗
 * -#  ۯ:
 *   - \code sysclk_init(); \endcode
 *   - \note ɕKvƂ܂񂪁A\ref usart_groupײނ \ref sysclk_group
 *           Ɉˑ邽߁A̒Pʕ邱Ƃ͗ǂHłB
 * -# USARTCӑI\̂쐬:
 *   - \code
 *       static usart_rs232_options_t USART_SERIAL_OPTIONS = {
 *          .baudrate = USART_SERIAL_BAUDRATE,
 *          .charlength = USART_SERIAL_CHAR_LENGTH,
 *          .paritytype = USART_SERIAL_PARITY,
 *          .stopbits = USART_SERIAL_STOP_BIT
 *       };
 *     \endcode
 * -# USAQRTPʕpۯ:
 *   - \code sysclk_enable_module(SYSCLK_PORT_D, PR_USART0_bm); \endcode
 * -# RS232ŏ:
 *   - \code usart_init_rs232(USART_SERIAL, &USART_SERIAL_OPTIONS);
 *     \endcode
 *
 * \section usart_use_case_1_usage giK
 *
 * \subsection usart_use_case_1_usage_code ޗ
 * Ⴆ΁ApÇقŎJԂɒǉ܂B:
 * \code
 *       received_byte = usart_getchar(USART_SERIAL);
 *       usart_putchar(USART_SERIAL, received_byte);
 * \endcode
 *
 * \subsection usart_use_case_1_usage_flow Ƃ̗
 * -# ̎M҂B:
 *   - \code received_byte = usart_getchar(USART_SERIAL); \endcode
 * -# 𑗂ԂB:
 *   - \code usart_putchar(USART_SERIAL, received_byte); \endcode
 */

#endif // _USART_H_
