/**
 * \file
 *
 * \brief ߓLUǗ֐
 *
 * 쌠 (c) 2010-2011 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef XMEGA_OSC_H_INCLUDED
#define XMEGA_OSC_H_INCLUDED

#include <compiler.h>
#include <board.h>

/**
 * \weakgroup osc_group
 *
 * \section osc_group_errata Q
 *   - ZXMEGA A1HƂȑOłœ܂B
 * @{
 */

//! \name U펯ʎq
//@{
#define OSC_ID_RC2MHZ			OSC_RC2MEN_bm	//!< 2MHzRCU
#define OSC_ID_RC32MHZ			OSC_RC32MEN_bm	//! 32MHzRCU
#define OSC_ID_RC32KHZ			OSC_RC32KEN_bm	//!< 32KHzRCU
#define OSC_ID_XOSC				OSC_XOSCEN_bm	//!< OU
/**
 * \brief USBڰъJn̎QƊ
 * \note ͋֎~邱Ƃł܂񂪁AZ(DFLL)pQƊƂ
 * gp邱Ƃł܂B
 */
#define OSC_ID_USBSOF			0xff
//@}

//! \name OU^
//@{
#define XOSC_TYPE_EXTERNAL		0	//!< OۯM
#define XOSC_TYPE_32KHZ			2	//!< TOSC32.768kHzUq
#define XOSC_TYPE_XTAL			3	//!< XTAL0.4`16MHzUq
//@}

/**
 * \def CONFIG_XOSC_32KHZ_LPM
 * \brief 32kHzOUɑ΂Ēd͓邽߂̒`
 */
#ifdef __DOXYGEN__
# define CONFIG_XOSC_32KHZ_LPM
#endif /* __DOXYGEN__ */

/**
 * \def CONFIG_XOSC_STARTUP
 * \brief BOARD_XOSC_STARTUP_USɊÂĊOUqɑ΂Ďn߂
 * ˑlBOSC.XOSCCTRLXOSCSEL̈2MSBɏ܂B
 *
 * \note ͎蓮Őݒ肳ȂꍇBOARD_XOSC_HZBOARD_XOSC_STARTUP_US
 * IɌvZ܂B
 */

//! \name XTALUqn
//@{
#define XOSC_STARTUP_256		0	//!< 256n
#define XOSC_STARTUP_1024		1	//!< 1kn
#define XOSC_STARTUP_16384		2	//!< 16kn
//@}

/**
 * \def CONFIG_XOSC_RANGE
 * \brief OU̎g͈͂ݒ肷ˑlBOSC.XOSCCTRL
 * FRQRANGËɏ܂B
 *
 * \note ͎蓮Őݒ肳ȂꍇBOARD_XOSC_HZ玩IɌvZ܂B
 */

//! \name XTALUqg͈
//@{
#define XOSC_RANGE_04TO2		OSC_FRQRANGE_04TO2_gc	//!< 0.4`2MHzg͈
#define XOSC_RANGE_2TO9			OSC_FRQRANGE_2TO9_gc	//!< 2`9MHzg͈
#define XOSC_RANGE_9TO12		OSC_FRQRANGE_9TO12_gc	//!< 9`12MHzg͈
#define XOSC_RANGE_12TO16		OSC_FRQRANGE_12TO16_gc	//!< 12`16MHzg͈
//@}

/**
 * \def XOSC_STARTUP_TIMEOUT
 * \brief Jnɑ΂XOSC҂s
 *
 * ͒ǉ25%S]TOSC0_STARTUP_VALUEɏ]葬ۯłB
 * U킪̐Ԃ𒴂ɓȂꍇAJnɎsƉ肳܂B
 */

// pXOSC̎gpӐ}ȂA
#ifdef BOARD_XOSC_HZ
// 蓮ݒ肳ȂꍇXOSCpn`Ԑݒ擾
# ifndef CONFIG_XOSC_STARTUP
#  ifndef BOARD_XOSC_STARTUP_US
#   error BOARD_XOSC_STARTUP_US must be configured.
#  else
//! \internal XOSCpn
#   define BOARD_XOSC_STARTUP_CYCLES \
		(BOARD_XOSC_HZ / 1000000 * BOARD_XOSC_STARTUP_US)

#   if (BOARD_XOSC_TYPE == XOSC_TYPE_XTAL)
#    if (BOARD_XOSC_STARTUP_CYCLES > 16384)
#     error BOARD_XOSC_STARTUP_US is too high for current BOARD_XOSC_HZ.

#    elif (BOARD_XOSC_STARTUP_CYCLES > 1024)
#     define CONFIG_XOSC_STARTUP    XOSC_STARTUP_16384
#     define XOSC_STARTUP_TIMEOUT   (16384*(1000000/BOARD_XOSC_HZ))

#    elif (BOARD_XOSC_STARTUP_CYCLES > 256)
#     define CONFIG_XOSC_STARTUP    XOSC_STARTUP_1024
#     define XOSC_STARTUP_TIMEOUT   (1024*(1000000/BOARD_XOSC_HZ))

#    else
#     define CONFIG_XOSC_STARTUP    XOSC_STARTUP_256
#     define XOSC_STARTUP_TIMEOUT   (256*(1000000/BOARD_XOSC_HZ))
#    endif
#   else /* BOARD_XOSC_TYPE == XOSC_TYPE_XTAL */
#    define CONFIG_XOSC_STARTUP     0
#   endif
#  endif /* BOARD_XOSC_STARTUP_US */
# endif /* CONFIG_XOSC_STARTUP */

// 蓮Őݒ肳ȂꍇXOSCpg͈͐ݒ擾
# ifndef CONFIG_XOSC_RANGE
#  if (BOARD_XOSC_TYPE == XOSC_TYPE_XTAL)
#   if (BOARD_XOSC_HZ < 400000)
#    error BOARD_XOSC_HZ is below minimum frequency of 400 kHz.

#   elif (BOARD_XOSC_HZ < 2000000)
#    define CONFIG_XOSC_RANGE    XOSC_RANGE_04TO2

#   elif (BOARD_XOSC_HZ < 9000000)
#    define CONFIG_XOSC_RANGE    XOSC_RANGE_2TO9

#   elif (BOARD_XOSC_HZ < 12000000)
#    define CONFIG_XOSC_RANGE    XOSC_RANGE_9TO12

#   elif (BOARD_XOSC_HZ <= 16000000)
#    define CONFIG_XOSC_RANGE    XOSC_RANGE_12TO16

#   else
#    error BOARD_XOSC_HZ is above maximum frequency of 16 MHz.
#   endif
#  else /* BOARD_XOSC_TYPE == XOSC_TYPE_XTAL */
#   define CONFIG_XOSC_RANGE     0
#  endif
# endif /* CONFIG_XOSC_RANGE */
#endif /* BOARD_XOSC_HZ */

#ifndef __ASSEMBLY__

/**
 * \internal
 * \brief U \a id 
 *
 * ̊֐𒼐ڌĂ΂ȂłBosc_enable()gpĂB
 */
static inline void osc_enable_internal(uint8_t id)
{
	irqflags_t flags;

	Assert(id != OSC_ID_USBSOF);

	flags = cpu_irq_save();
	OSC.CTRL |= id;
	cpu_irq_restore(flags);
}

#if defined(BOARD_XOSC_HZ) || defined(__DOXYGEN__)

/**
 * \internal
 * \brief OU \a id 
 *
 * ̊֐𒼐ڌĂ΂ȂłBosc_enable()gpĂB
 * AۂɊOUؽقꍇɂ̊֐p\ȂƂɒ
 * ӂĂB
 */
static inline void osc_enable_external(uint8_t id)
{
	irqflags_t flags;

	Assert(id == OSC_ID_XOSC);

#ifndef CONFIG_XOSC_32KHZ_LPM
	OSC.XOSCCTRL = BOARD_XOSC_TYPE | (CONFIG_XOSC_STARTUP << 2) |
			CONFIG_XOSC_RANGE;
#else
	OSC.XOSCCTRL = BOARD_XOSC_TYPE | (CONFIG_XOSC_STARTUP << 2) |
			CONFIG_XOSC_RANGE | OSC_X32KLPM_bm;
#endif /* CONFIG_XOSC_32KHZ_LPM */

	flags = cpu_irq_save();
	OSC.CTRL |= id;
	cpu_irq_restore(flags);
}
#else

static inline void osc_enable_external(uint8_t id)
{
	Assert(false);	// I񂾊ɊOUȂ
}
#endif

static inline void osc_disable(uint8_t id)
{
	irqflags_t flags;

	Assert(id != OSC_ID_USBSOF);

	flags = cpu_irq_save();
	OSC.CTRL &= ~id;
	cpu_irq_restore(flags);
}

static inline void osc_enable(uint8_t id)
{
	if (id != OSC_ID_XOSC) {
		osc_enable_internal(id);
	} else {
		osc_enable_external(id);
	}
}

static inline bool osc_is_ready(uint8_t id)
{
	Assert(id != OSC_ID_USBSOF);

	return OSC.STATUS & id;
}

//! \name XMEGALU@\
//@{

/**
 * \brief DFLLɊÂU̎Z
 *
 * XMEGA2MHz32MHz̓U̐xP邽߂ɗp邱Ƃł2
 * ޼َgH(DFLL)łBDFLL͔ȖsZs߂ɔ
 * UgƐmȎQƊۯƔr܂B
 *
 * ̋@\͎QƊƂ32.768kHzZtU܂͊OؽٔÛ
 * 炩p2MHz܂32MHẑǂ炩̓Uɑ΂鎩Z
 * B҂̔CӑIgpꍇAؽقTOSC݂ɐڑ32.768kHző
 * sȂ΂Ȃ܂B
 *
 * \param	id		Z锭UID
 * \arg				\c OSC_ID_RC2MHZ܂\c OSC_ID_RC32MHZ
 * \param	ref_id	QƊƂĎgp锭UID
 * \arg				܂͊O32kHzQƊɑ΂āAeXA\c OSC_ID_RC32KHZ܂\c OSC_ID_XOSC
 * \arg				USBp\œĂ鎞ɂ32MHzɑ΂āA\c OSC_ID_USBSOF
 */
static inline void osc_enable_autocalibration(uint8_t id, uint8_t ref_id)
{
	irqflags_t flags;

	flags = cpu_irq_save();
	switch (id) {
	case OSC_ID_RC2MHZ:
		Assert((ref_id == OSC_ID_RC32KHZ) || (ref_id == OSC_ID_XOSC));

		if (ref_id == OSC_ID_XOSC) {
			OSC.DFLLCTRL |= OSC_RC2MCREF_bm;
		} else {
			OSC.DFLLCTRL &= ~(OSC_RC2MCREF_bm);
		}
		DFLLRC2M.CTRL |= DFLL_ENABLE_bm;
		break;

	case OSC_ID_RC32MHZ:
#if XMEGA_AU || XMEGA_B || XMEGA_C
		Assert((ref_id == OSC_ID_RC32KHZ)
				|| (ref_id == OSC_ID_XOSC)
				|| (ref_id == OSC_ID_USBSOF));

		OSC.DFLLCTRL &= ~(OSC_RC32MCREF_gm);

		if (ref_id == OSC_ID_XOSC) {
			OSC.DFLLCTRL |= OSC_RC32MCREF_XOSC32K_gc;
		}
		else if (ref_id == OSC_ID_USBSOF) {
			/*  USBSOFp48MHz32MHz RCZ(48MHz/1kHz=0xBB80) */
			DFLLRC32M.COMP1 = 0x80;
			DFLLRC32M.COMP2 = 0xBB;
			OSC.DFLLCTRL |= OSC_RC32MCREF_USBSOF_gc;
		}
		else if (ref_id == OSC_ID_RC32KHZ) {
			/*  USBSOFp48MHz32MHz RCZ(48MHz/1kHz=0xBB80) ? */
			DFLLRC32M.COMP1 = 0x80;
			DFLLRC32M.COMP2 = 0xBB;
			osc_enable(OSC_ID_RC32KHZ);
			OSC.DFLLCTRL |= OSC_RC32MCREF_RC32K_gc;
		}
#else
		Assert((ref_id == OSC_ID_RC32KHZ) || (ref_id == OSC_ID_XOSC));

		if (ref_id == OSC_ID_XOSC) {
			OSC.DFLLCTRL |= OSC_RC32MCREF_bm;
		}
		else {
			OSC.DFLLCTRL &= ~(OSC_RC32MCREF_bm);
		}
#endif
		DFLLRC32M.CTRL |= DFLL_ENABLE_bm;
		break;

	default:
		Assert(false);
		break;
	}
	cpu_irq_restore(flags);
}

/**
 * \brief DFLLɊÂU̎Z֎~
 *
 * \see osc_enable_autocalibration
 *
 * \param	id	Z֎~锭UID
 * \arg			\c OSC_ID_RC2MHZ܂\c OSC_ID_RC32MHZ
 */
static inline void osc_disable_autocalibration(uint8_t id)
{
	switch (id) {
	case OSC_ID_RC2MHZ:
		DFLLRC2M.CTRL = 0;
		break;

	case OSC_ID_RC32MHZ:
		DFLLRC32M.CTRL = 0;
		break;

	default:
		Assert(false);
		break;
	}
}

/**
 * \brief w肵UɎwZlݒ
 *
 * \param	id		Zlݒ肷锭UID
 * \arg				\c OSC_ID_RC2MHZ܂\c OSC_ID_RC32MHZ.
 * \param	calib	KvƂwZl
 *
 */
static inline void osc_user_calibration(uint8_t id, uint16_t calib)
{
	switch (id) {
	case OSC_ID_RC2MHZ:
		DFLLRC2M.CALA=LSB(calib);
		DFLLRC2M.CALB=MSB(calib);
		break;

	case OSC_ID_RC32MHZ:
		DFLLRC32M.CALA=LSB(calib);
		DFLLRC32M.CALB=MSB(calib);
		break;

	default:
		Assert(false);
		break;
	}
}
//@}

static inline uint32_t osc_get_rate(uint8_t id)
{
	Assert(id != OSC_ID_USBSOF);

	switch (id) {
	case OSC_ID_RC2MHZ:
		return 2000000UL;

	case OSC_ID_RC32MHZ:
#ifdef CONFIG_OSC_RC32_CAL
		return CONFIG_OSC_RC32_CAL;
#else
		return 32000000UL;
#endif

	case OSC_ID_RC32KHZ:
		return 32768UL;

#ifdef BOARD_XOSC_HZ
	case OSC_ID_XOSC:
		return BOARD_XOSC_HZ;
#endif

	default:
		Assert(false);
		return 0;
	}
}

#endif /* __ASSEMBLY__ */

//! @}

#endif /* XMEGA_OSC_H_INCLUDED */
