/**
 * \file
 *
 * \brief ߓLؾČ֐
 *
 * 쌠 (C) 2010-2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef XMEGA_DRIVERS_CPU_RESET_CAUSE_H
#define XMEGA_DRIVERS_CPU_RESET_CAUSE_H

#include "compiler.h"
#include "ccp.h"

/**
 * \ingroup reset_cause_group
 * \defgroup xmega_reset_cause_group XMEGAؾČ
 *
 * \ref reset_cause_quickstartB
 *
 * @{
 */

/**
 * \brief SĂ ؾČێ\͂ߓLؾČ^BʓI
 * Čڼ޽̑傫𔽉f܂B
 */
typedef uint8_t			reset_cause_t;

//! \internal \name ߓLؾČ
//@{
#define CHIP_RESET_CAUSE_EXTRST		RST_EXTRF_bm	//!< \internal OؾČ
#define CHIP_RESET_CAUSE_BOD_IO		RST_BORF_bm		//!< \internal CPUɑ΂ĂƓAdoؾČ
#define CHIP_RESET_CAUSE_BOD_CPU	RST_BORF_bm		//!< \internal I/Oɑ΂ĂƓAdoؾČ
#define CHIP_RESET_CAUSE_OCD		RST_PDIRF_bm	//!< \internal ̏ޯ  ؾČ
#define CHIP_RESET_CAUSE_POR		RST_PORF_bm		//!< \internal dONؾČ
#define CHIP_RESET_CAUSE_SOFT		RST_SRF_bm		//!< \internal ĳ ؾČ
#define CHIP_RESET_CAUSE_SPIKE		RST_SDRF_bm		//!< \internal ߲oؾČ
#define CHIP_RESET_CAUSE_WDT		RST_WDRF_bm		//!< \internal ޯގԒؾČ
//@}

static inline reset_cause_t reset_cause_get_causes(void)
{
	return (reset_cause_t)RST.STATUS;
}

static inline void reset_cause_clear_causes(reset_cause_t causes)
{
	RST.STATUS = causes;
}

static inline void reset_do_soft_reset(void)
{
	ccp_write_io((void *)&RST.CTRL, RST_SWRST_bm);

	while (1) {
		/* Ӑ}Iȋ */
	}
}

//! @}

#endif /* XMEGA_DRIVERS_CPU_RESET_CAUSE_H */
