/**
 * \file
 *
 * \brief ʓIɎgpAݸٰށA^Aϸ
 *
 * 쌠 (c) 2010-2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef UTILS_COMPILER_H
#define UTILS_COMPILER_H

/**
 * \defgroup group_xmega_utils XMEGA߲ ײ
 *
 * 8ޯAVRp߲גۑwƺ հèè
 * ̒Pʕ͊e߲׊Ԃł̌݊ނ邽߂̗lXȒۑw°èè
 * ܂B
 *
 * \{
 */

#if defined(__GNUC__)
#  include <avr/io.h>
#  include <avr/builtins.h>
#elif defined(__ICCAVR__)
#  include <ioavr.h>
#  include <intrinsics.h>
#else
#  error Unsupported compiler.
#endif

#include <stdbool.h>
#include <stdint.h>
#include <stddef.h>
#include <stdlib.h>

#include <parts.h>

#ifdef __ICCAVR__
/*! \name ߲ ܰ
 *
 * GCCIAR Embedded Workbenchւ̷ܰނ̈ڐA
 */
//! @{
#define __asm__			asm
#define __inline__		inline
#define __volatile__
//! @}
#endif

/**
 * \def barrier
 * \brief ؏
 */
#ifdef __GNUC__
#  define barrier()		asm volatile("" ::: "memory")
#else
#  define barrier()		asm ("")
#endif

/**
 * \brief ߲ ۸ \a argo
 *
 * \param	arg		\e \#pragmaɌ鎞׸ώw
 *					(A񉻂ĂȂ)
 */
#define COMPILER_PRAGMA(arg)		_Pragma(#arg)

/*
 * AVR{\͂ƂɂɂċCɂ܂B
 */
#define COMPILER_PACK_RESET(alignment)
#define COMPILER_PACK_SET(alignment)

/**
 * \brief 񂵂Eɐݒ
 */
#if (defined __GNUC__)
#define COMPILER_ALIGNED(a)			__attribute__((__aligned__(a)))
#elif (defined __ICCAVR__)
#define COMPILER_ALIGNED(a)			COMPILER_PRAGMA(data_alignment = a)
#endif

/**
 * \brief ꐮ񂵂Eɐݒ
 */
#if (defined __GNUC__)
#define COMPILER_WORD_ALIGNED		__attribute__((__aligned__(2)))
#elif (defined __ICCAVR__)
#define COMPILER_WORD_ALIGNED		COMPILER_PRAGMA(data_alignment = 2)
#endif

/**
 * \name ʌ݊ƂĊ֐Dt
 *
 * ʌ݊ƂĂ̊֐Dt͊֐Ă΂ꂽɂx𐶐܂B
 *
 * g͊֐`̑O__DEPRECATED__قǉ邱ƂłB
 * Ⴆ:
 * __DEPRECATED__ uint8_t some_deprecated_function (void)
 * {
 *     ...
 * }
 *
 * \note GCC 3.1Ƃȍ~ɂĂ̂ݎxAIAR͕sx
 * @{
 */
#if ((defined __GNUC__) && (__GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ >=1)))
#define __DEPRECATED__  __attribute__((__deprecated__))
#else
#define __DEPRECATED__
#endif
//! @}

/*! \name Usual Types
 */
//! @{
typedef unsigned char           Bool;	//!< ްْl
#ifndef __cplusplus
#if !defined(__bool_true_false_are_defined)
typedef unsigned char           bool;	//!< ްْl
#endif
#endif
typedef signed char             S8 ;	//!< 8ޯĕt
typedef unsigned char           U8 ;	//!< 8ޯĕȂ
typedef signed short int        S16;	//!< 16ޯĕt
typedef unsigned short int      U16;	//!< 16ޯĕȂ
typedef unsigned short int      le16_t;
typedef unsigned short int      be16_t;
typedef signed long int         S32;	//!< 32ޯĕt
typedef unsigned long int       U32;	//!< 32ޯĕȂ
typedef uint32_t                le32_t;
typedef uint32_t                be32_t;
typedef signed long long int    S64;	//!< 64ޯĕt
typedef unsigned long long int  U64;	//!< 64ޯĕȂ
typedef float                   F32;	//!< 32ޯĕs_
typedef double                  F64;	//!< 64ޯĕs_
typedef uint16_t                iram_size_t;
//! @}


/*! \name Ԍ^
 */
//! @{
typedef Bool                Status_bool_t;		//!< ްْl
typedef U8                  Status_t;       	//!< 8ޯĕ
//! @}


/*! \name ʖWv^
 */
//! @{

//! 16ޯċp
typedef union
{
  S16 s16   ;
  U16 u16   ;
  S8  s8 [2];
  U8  u8 [2];
} Union16;

//! 32ޯċp
typedef union
{
  S32 s32   ;
  U32 u32   ;
  S16 s16[2];
  U16 u16[2];
  S8  s8 [4];
  U8  u8 [4];
} Union32;

//! 64ޯċp
typedef union
{
  S64 s64   ;
  U64 u64   ;
  S32 s32[2];
  U32 u32[2];
  S16 s16[4];
  U16 u16[4];
  S8  s8 [8];
  U8  u8 [8];
} Union64;

//! 64,32,16,8ޯĕȂւ߲̋p
typedef union
{
  S64 *s64ptr;
  U64 *u64ptr;
  S32 *s32ptr;
  U32 *u32ptr;
  S16 *s16ptr;
  U16 *u16ptr;
  S8  *s8ptr ;
  U8  *u8ptr ;
} UnionPtr;

//! volatile 64,32,16,8ޯĕȂւ߲̋p
typedef union
{
  volatile S64 *s64ptr;
  volatile U64 *u64ptr;
  volatile S32 *s32ptr;
  volatile U32 *u32ptr;
  volatile S16 *s16ptr;
  volatile U16 *u16ptr;
  volatile S8  *s8ptr ;
  volatile U8  *u8ptr ;
} UnionVPtr;

//! constant 64,32,16,8ޯĕȂւ߲̋p
typedef union
{
  const S64 *s64ptr;
  const U64 *u64ptr;
  const S32 *s32ptr;
  const U32 *u32ptr;
  const S16 *s16ptr;
  const U16 *u16ptr;
  const S8  *s8ptr ;
  const U8  *u8ptr ;
} UnionCPtr;

//! constant volatile 64,32,16,8ޯĕȂւ߲̋p
typedef union
{
  const volatile S64 *s64ptr;
  const volatile U64 *u64ptr;
  const volatile S32 *s32ptr;
  const volatile U32 *u32ptr;
  const volatile S16 *s16ptr;
  const volatile U16 *u16ptr;
  const volatile S8  *s8ptr ;
  const volatile U8  *u8ptr ;
} UnionCVPtr;

//! 64,32,16,8ޯĕȂւ߲̍\
typedef struct
{
  S64 *s64ptr;
  U64 *u64ptr;
  S32 *s32ptr;
  U32 *u32ptr;
  S16 *s16ptr;
  U16 *u16ptr;
  S8  *s8ptr ;
  U8  *u8ptr ;
} StructPtr;

//! volatile 64,32,16,8ޯĕȂւ߲̍\
typedef struct
{
  volatile S64 *s64ptr;
  volatile U64 *u64ptr;
  volatile S32 *s32ptr;
  volatile U32 *u32ptr;
  volatile S16 *s16ptr;
  volatile U16 *u16ptr;
  volatile S8  *s8ptr ;
  volatile U8  *u8ptr ;
} StructVPtr;

//! constant 64,32,16,8ޯĕȂւ߲̍\
typedef struct
{
  const S64 *s64ptr;
  const U64 *u64ptr;
  const S32 *s32ptr;
  const U32 *u32ptr;
  const S16 *s16ptr;
  const U16 *u16ptr;
  const S8  *s8ptr ;
  const U8  *u8ptr ;
} StructCPtr;

//! constant volatile 64,32,16,8ޯĕȂւ߲̍\
typedef struct
{
  const volatile S64 *s64ptr;
  const volatile U64 *u64ptr;
  const volatile S32 *s32ptr;
  const volatile U32 *u32ptr;
  const volatile S16 *s16ptr;
  const volatile U16 *u16ptr;
  const volatile S8  *s8ptr ;
  const volatile U8  *u8ptr ;
} StructCVPtr;

//! @}


//_____ ϸ ________________________________________________________

/*! \name ʏ̒萔
 */
//! @{
#define DISABLE		0
#define ENABLE		1
#ifndef __cplusplus
#if !defined(__bool_true_false_are_defined)
#define false		0
#define true		1
#endif
#endif
#define PASS		0
#define FAIL		1
#define LOW			0
#define HIGH		1
//! @}


//! \name َ߲Ԉُ폈
//@{

/**
 * \internal
 * \def ERROR_FUNC(name, msg)
 * \brief ֐Ăяoꂽꍇَ̺߲s
 *
 * ׂ߲\a name֐ɑ΂SĂ̌Ăяo̍œKsꍇA߲قI
 * Ďgp҂\a msg\܂B
 *
 * \note SĂׂ̺߲gpł͂ȂÂɂ͍őPw͂łB
 * XAݶȏɂȂ邩ꂸAœK֎~ƁA̋@\͊S
 * ɋ֎~܂B
 */
#ifndef ERROR_FUNC
# define ERROR_FUNC(name, msg)                      \
	extern int name(void)
#endif

//@}

//! \name ֐ĂяoI
//@{

//! sIɑ΂ُ֐
ERROR_FUNC(compiler_demux_bad_size, "Invalid parameter size");

/**
 * \internal
 * \brief ް^̑傫ɊÂĊ֐𕪗I
 *
 * ް^̑傫ɉĐڔ8,16,32֐Ɋ֐Ăяo]B֐
 * ǂҰnƂł܂B
 *
 * g:
 * \code
 * void foo8(uint8_t a, void *b);
 * void foo16(uint16_t a, void *b);
 * void foo32(uint32_t a, void *b);
 *
 * #define foo(x, y)    compiler_demux_size(sizeof(x), foo, x, y)
 * \endcode
 *
 * \param	size	ް^̑傫
 * \param	func	{֐
 * \param	...		֐֓nҰ̈ꗗ
 */
#define compiler_demux_size(size, func, ...)        \
	(((size) == 1) ? func##8(__VA_ARGS__) :     \
	 ((size) == 2) ? func##16(__VA_ARGS__) :    \
	 ((size) == 4) ? func##32(__VA_ARGS__) :    \
	 compiler_demux_bad_size())

//@}

/**
 * \def __always_inline
 * \brief ֐͏ɲײׂ݉łB
 *
 * ̒Lͺׂ߲ɂ̑̌wKIײ݉𖳎Ăꂪǂʑ傫Ȃ邩
 * Ɋւ炸Ɋ֐ײ݉悤Ɏw܂B
 */
#if (defined __GNUC__)
	#define __always_inline		inline __attribute__((__always_inline__))
#elif (defined __ICCAVR__)
	#define __always_inline		_Pragma("inline=forced")
#endif

//! \name œK
//@{

/**
 * \def __always_optimize
 * \brief ֐͏ɍœKׂłB
 *
 * ̒Lͺׂ߲ɑS̓IȍœKݒ𖳎Ċ֐ɍʂ̍œKź߲
 * 悤Ɏw܂B
 */
#if (defined __GNUC__)
	#define __always_optimize	__attribute__((optimize(3)))
#elif (defined __ICCAVR__)
	#define __always_optimize	_Pragma("optimize=high")
#endif

/**
 * \def likely(exp)
 * \brief \a exp͐^(true)ŗL肻łB
 */
#ifndef likely
# define likely(exp)	(exp)
#endif

/**
 * \def unlikely(exp)
 * \brief \a exp͐^(true)łȂłB
 */
#ifndef unlikely
# define unlikely(exp)	(exp)
#endif

/**
 * \def is_constant(exp)
 * \brief 萔lɕ]邩f
 *
 * \param	exp		ꂩ̎
 *
 * \return \a exp萔Ȃΐ^(true)AȂ΋U(false)
 */
#ifdef __GNUC__
# define is_constant(exp)	__builtin_constant_p(exp)
#else
# define is_constant(exp)	(0)
#endif

//! @}

/*! \name ޯė̈揈
 */
#include "bit_handling/clz_ctz.h"
//! @{

/*! \brief ^ꂽޯĎՕɂĎw肳lޯĂǂݍ
 *
 * \param	value	ޯĂǂޒl
 * \param	mask	ǂޯĂޯĎՕ
 *
 * \return ǂޯ
 */
#define Rd_bits( value, mask)	((value)&(mask))

/*! \brief ^ꂽޯĎՕɂĎw肳CӒlޯď
 *
 * \param	lvalue	ޯĂCӒl
 * \param	mask	ޯĂޯĎՕ
 * \param	bits	ޯ
 *
 * \return ꂽޯĂʒl
 */
#define Wr_bits(lvalue, mask, bits)  ((lvalue) = ((lvalue) & ~(mask)) |\
                                                 ((bits  ) &  (mask)))

/*! \brief ^ꂽޯĎՕɂĎw肳lޯČ
 *
 * \param	value	ޯČl
 * \param	mask	ޯĂޯĎՕ
 *
 * \return ޯĂ̍Œ1ݒȂ\c 1AłȂ\c 0
 */
#define Tst_bits( value, mask)  (Rd_bits(value, mask) != 0)

/*! \brief ^ꂽޯĎՕɂĎw肳CӒlޯĂ
 *
 * \param	lvalue	ޯĂCӒl
 * \param	mask	ޯĂޯĎՕ
 *
 * \return ޯĂʒl
 */
#define Clr_bits(lvalue, mask)  ((lvalue) &= ~(mask))

/*! \brief ^ꂽޯĎՕɂĎw肳CӒlޯĂݒ
 *
 * \param	lvalue	ޯĂݒ肷CӒl
 * \param	mask	ݒ肷ޯĂޯĎՕ
 *
 * \return ݒ肵ޯĂʒl
 */
#define Set_bits(lvalue, mask)  ((lvalue) |=  (mask))

/*! \brief ^ꂽޯĎՕɂĎw肳CӒlޯĂ𔽓]
 *
 * \param	lvalue	ޯĂ𔽓]CӒl
 * \param	mask	]ޯĂޯĎՕ
 *
 * \return ]ޯĂʒl
 */
#define Tgl_bits(lvalue, mask)  ((lvalue) ^=  (mask))

/*! \brief ^ꂽޯĎՕɂĎw肳lޯė̈ǂݍ
 *
 * \param	value	ޯė̈ǂޒl
 * \param	mask	ǂޯė̈ޯĎՕ
 *
 * \return ǂޯė̈
 */
#define Rd_bitfield( value,mask)    (Rd_bits( value, (uint32_t)mask) >> ctz(mask))

/*! \brief ^ꂽޯĎՕɂĎw肳lޯė̈
 *
 * \param	value		ޯė̈CӒl
 * \param	mask		ޯė̈ޯĎՕ
 * \param	bitfield	ޯė̈
 *
 * \return ꂽޯė̈ʒl
 */
#define Wr_bitfield(lvalue, mask, bitfield) (Wr_bits(lvalue, mask, (uint32_t)(bitfield) << ctz(mask)))

//! @}


/*! \brief ϸۂ͒vIُ팟Ɏgp܂B
 *
 * ϸۂ͎肩܂BȂ΁AvIُ킪oAp͒f
 * ܂BTEST_SUITE_DEFINE_ASSERT_MACRO`ꍇA̍XȂ錟
 * ̎s߂ϸۂ̒Pʌłgp܂B
 *
 * \param	expr	]0łȂ̎
 */
#if defined(_ASSERT_ENABLE_)
#  if defined(TEST_SUITE_DEFINE_ASSERT_MACRO)
	// Assert()unit_test/suite.hŒ`܂B
#    include "unit_test/suite.h"
#  else
#    define Assert(expr) \
	{\
		if (!(expr)) while (true);\
	}
#  endif
#else
#  define Assert(expr) ((void) 0)
#endif

/*! \name ޯĔ]
 */
//! @{

/*! \brief \a u8ޯĂ𔽓]
 *
 * \param	u8	ޯĂ𔽓]U8
 *
 * \return ]ޯĂ\a u8̌ʒl
 */
#define bit_reverse8(u8)    ((U8)(bit_reverse32((U8)(u8)) >> 24))

/*! \brief \a u16ޯĂ𔽓]
 *
 * \param	u16		ޯĂ𔽓]U16
 *
 * \return ]ޯĂ\a u16̌ʒl
 */
#define bit_reverse16(u16)  ((U16)(bit_reverse32((U16)(u16)) >> 16))

/*! \brief \a u32ޯĂ𔽓]
 *
 * \param	u32		ޯĂ𔽓]U32
 *
 * \return ]ޯĂ\a u32̌ʒl
 */
#if (defined __GNUC__)
  #define bit_reverse32(u32) \
  (\
    {\
      unsigned int __value = (U32)(u32);\
      __asm__ ("brev\t%0" : "+r" (__value) :  : "cc");\
      (U32)__value;\
    }\
  )
#elif (defined __ICCAVR__)
  #define bit_reverse32(u32)  ((U32)__bit_reverse((U32)(u32)))
#endif

/*! \brief \a u64ޯĂ𔽓]
 *
 * \param	u64		ޯĂ𔽓]U64
 *
 * \return ]ޯĂ\a u64̌ʒl
 */
#define bit_reverse64(u64)  ((U64)(((U64)bit_reverse32((U64)(u64) >> 32)) |\
                                   ((U64)bit_reverse32((U64)(u64)) << 32)))

//! @}

//! \name ΐ֐
//! @{

/**
 * \internal
 * `֐BȒ萔lilog2()Ă΂ꂽꍇݸs
 */
int_fast8_t ilog2_undefined(void);

/**
 * \brief l̒2Ƃΐł߂։ۂ߂vZ
 *
 * \param	x	32ޯĒl
 * \return \a x̒2ƂΐA܂\a x0̏ꍇ-1
 */
static inline int_fast8_t ilog2(uint32_t x)
{
	if (is_constant(x))
		return ((x) & (1ULL << 31) ? 31 :
			(x) & (1ULL << 30) ? 30 :
			(x) & (1ULL << 29) ? 29 :
			(x) & (1ULL << 28) ? 28 :
			(x) & (1ULL << 27) ? 27 :
			(x) & (1ULL << 26) ? 26 :
			(x) & (1ULL << 25) ? 25 :
			(x) & (1ULL << 24) ? 24 :
			(x) & (1ULL << 23) ? 23 :
			(x) & (1ULL << 22) ? 22 :
			(x) & (1ULL << 21) ? 21 :
			(x) & (1ULL << 20) ? 20 :
			(x) & (1ULL << 19) ? 19 :
			(x) & (1ULL << 18) ? 18 :
			(x) & (1ULL << 17) ? 17 :
			(x) & (1ULL << 16) ? 16 :
			(x) & (1ULL << 15) ? 15 :
			(x) & (1ULL << 14) ? 14 :
			(x) & (1ULL << 13) ? 13 :
			(x) & (1ULL << 12) ? 12 :
			(x) & (1ULL << 11) ? 11 :
			(x) & (1ULL << 10) ? 10 :
			(x) & (1ULL <<  9) ?  9 :
			(x) & (1ULL <<  8) ?  8 :
			(x) & (1ULL <<  7) ?  7 :
			(x) & (1ULL <<  6) ?  6 :
			(x) & (1ULL <<  5) ?  5 :
			(x) & (1ULL <<  4) ?  4 :
			(x) & (1ULL <<  3) ?  3 :
			(x) & (1ULL <<  2) ?  2 :
			(x) & (1ULL <<  1) ?  1 :
			(x) & (1ULL <<  0) ?  0 :
			ilog2_undefined());

	return 31 - clz(x);
}

//! @}

/*! \name 
 */
//! @{

/*! \brief \a nE\a val̐l̐
 *
 * \param	val		͒l
 * \param	n		E
 *
 * \return \a val̐l\a nEŐ̏ꍇ\c 1AłȂ\c 0
 */
#define Test_align(val, n     ) (!Tst_bits( val, (n) - 1     )   )

/*! \brief \a nɊւ\a val̐l̐擾
 *
 * \param	val		͒l
 * \param	n		E
 *
 * \return \a nɊւ\a val̐l̐
 */
#define Get_align( val, n     ) (  Rd_bits( val, (n) - 1     )   )

/*! \brief \a nEɊւ\a lvalӒl̐l̐\a algɐݒ
 *
 * \param	lval	o͍Ӓl
 * \param	n		E
 * \param	alg		
 *
 * \return \a nEɊւ\a algɐݒ肷邻̐񂩂̌ʂ\a lval̐Vl
 */
#define Set_align(lval, n, alg) (  Wr_bits(lval, (n) - 1, alg)   )

/*! \brief 㑤\a nE\a val̐l𐮗
 *
 * \param	val		͒l
 * \param	n		E
 *
 * \return 㑤\a nEŐ񂳂ꂽ\a val̐ľʒl
 */
#define Align_up(  val, n     ) (((val) + ((n) - 1)) & ~((n) - 1))

/*! \brief \a nE\a val̐l𐮗
 *
 * \param	val		͒l
 * \param	n		E
 *
 * \return \a nEŐ񂳂ꂽ\a val̐ľʒl
 */
#define Align_down(val, n     ) ( (val)              & ~((n) - 1))

//! @}


/*! \name w
 *
 * 萔ɑ΂߲׍œKAWinQVRABSp
 */
//! @{

/*! \brief \a a̐Βl
 *
 * \param	a	͒l
 *
 * \return \a a̐Βl
 *
 * \note َ߲Ɋm̒lŎgp邾̏ꍇɂƍœK
 */
#define Abs(a)              (((a) <  0 ) ? -(a) : (a))
#ifndef abs
#define abs(a)              Abs(a)
#endif

/*! \brief \a a\a b̍ŏlB
 *
 * \param	a	͒l
 * \param	b	͒l
 *
 * \return \a a\a b̍ŏl
 *
 * \note َ߲Ɋm̒lŎgp邾̏ꍇɂƍœK
 */
#define Min(a, b)           (((a) < (b)) ?  (a) : (b))
#define min(a, b)           Min(a, b)

/*! \brief\a a\a b̍őlB
 *
 * \param	a	͒l
 * \param	b	͒l
 *
 * \return \a a\a b̍ől
 *
 * \note َ߲Ɋm̒lŎgp邾̏ꍇɂƍœK
 */
#define Max(a, b)           (((a) > (b)) ?  (a) : (b))
#define max(a, b)           Max(a, b)

//! @}


/*! \brief \a addṟڽٰ݂Ăяo
 *
 * ͒Ăяoߺނ𐶐܂B
 *
 * Ⴆ΁A`Long_call(0x80000000)'͂ꂪCPUǗ삩ĂяoꂽꍇUC3
 * ł̿ĳ ؾĂ𐶐܂A
 *
 * \param	addr	Ăٰ݂̱ڽ
 *
 * \note ̓ʂŒߺނƂĎgp邩܂B
 */
#define Long_call(addr)                   ((*(void (*)(void))(addr))())

/*! \name  ڼ޽ 
 */
//! @{

/*! \brief \a sysreg  ڼ޽̒l擾
 *
 * \param	sysreg	l𓾂鼽 ڼ޽̱ڽ
 *
 * \return \a sysreg  ڼ޽̒l
 */
#if (defined __GNUC__)
  #define Get_system_register(sysreg)         __builtin_mfsr(sysreg)
#elif (defined __ICCAVR__)
  #define Get_system_register(sysreg)         __get_system_register(sysreg)
#endif

/*! \brief \a sysreg  ڼ޽̒l\a valueɐݒ
 *
 * \param	sysreg	lݒ肷鼽 ڼ޽̱ڽ
 * \param	value	\a sysreg  ڼ޽ɐݒ肷l
 */
#if (defined __GNUC__)
  #define Set_system_register(sysreg, value)  __builtin_mtsr(sysreg, value)
#elif (defined __ICCAVR__)
  #define Set_system_register(sysreg, value)  __set_system_register(sysreg, value)
#endif

//! @}

/*! \name ޯ ڼ޽ 
 */
//! @{

/*! \brief \a dbgreg ޯ ڼ޽̒l擾
 *
 * \param	dbgreg	l𓾂ޯ ڼ޽̱ڽ
 *
 * \return \a dbgreg ޯ ڼ޽̒l
 */
#if (defined __GNUC__)
  #define Get_debug_register(dbgreg)          __builtin_mfdr(dbgreg)
#elif (defined __ICCAVR__)
  #define Get_debug_register(dbgreg)          __get_debug_register(dbgreg)
#endif

/*! \brief \a dbgreg ޯ ڼ޽̒l\a valueɐݒ
 *
 * \param	dbgreg	lݒ肷ޯ ڼ޽̱ڽ
 * \param	value	\a dbgreg ޯ ڼ޽ɐݒ肷l
 */
#if (defined __GNUC__)
  #define Set_debug_register(dbgreg, value)   __builtin_mtdr(dbgreg, value)
#elif (defined __ICCAVR__)
  #define Set_debug_register(dbgreg, value)   __set_debug_register(dbgreg, value)
#endif

//! @}


/*! \name MCUިݏ
 * XMEGA ި݂MCUłB
 */
//! @{
#define  MSB(u16)		(((uint8_t* )&u16)[1])
#define  LSB(u16)		(((uint8_t* )&u16)[0])

#define  MSW(u32)		(((uint16_t*)&u32)[1])
#define  LSW(u32)		(((uint16_t*)&u32)[0])
#define  MSB0W(u32)		(((uint8_t*)&(u32))[3])	//!< u32̑1ʂ̍ŏ޲
#define  MSB1W(u32)		(((uint8_t*)&(u32))[2])	//!< u32̑2ʂ̍ŏ޲
#define  MSB2W(u32)		(((uint8_t*)&(u32))[1])	//!< u32̑3ʂ̍ŏ޲
#define  MSB3W(u32)		(((uint8_t*)&(u32))[0])	//!< u32̑4ʂ̍ŏ޲
#define  LSB3W(u32)		MSB0W(u32)				//!< u32̑4ʂ̍ŉ޲
#define  LSB2W(u32)		MSB1W(u32)				//!< u32̑3ʂ̍ŉ޲
#define  LSB1W(u32)		MSB2W(u32)				//!< u32̑2ʂ̍ŉ޲
#define  LSB0W(u32)		MSB3W(u32)				//!< u32̑1ʂ̍ŉ޲

#define  MSB0(u32)		(((uint8_t*)&u32)[3])
#define  MSB1(u32)		(((uint8_t*)&u32)[2])
#define  MSB2(u32)		(((uint8_t*)&u32)[1])
#define  MSB3(u32)		(((uint8_t*)&u32)[0])
#define  LSB0(u32)		MSB3(u32)
#define  LSB1(u32)		MSB2(u32)
#define  LSB2(u32)		MSB1(u32)
#define  LSB3(u32)		MSB0(u32)

#define  LE16(x)		(x)
#define  le16_to_cpu(x)	(x)
#define  cpu_to_le16(x)	(x)
#define  LE16_TO_CPU(x)	(x)
#define  CPU_TO_LE16(x)	(x)

#define  BE16(x)		Swap16(x)
#define  be16_to_cpu(x)	swap16(x)
#define  cpu_to_be16(x)	swap16(x)
#define  BE16_TO_CPU(x)	Swap16(x)
#define  CPU_TO_BE16(x)	Swap16(x)

#define  LE32(x)		(x)
#define  le32_to_cpu(x)	(x)
#define  cpu_to_le32(x)	(x)
#define  LE32_TO_CPU(x)	(x)
#define  CPU_TO_LE32(x)	(x)

#define  BE32(x)		Swap32(x)
#define  be32_to_cpu(x)	swap32(x)
#define  cpu_to_be32(x)	swap32(x)
#define  BE32_TO_CPU(x)	Swap32(x)
#define  CPU_TO_BE32(x)	Swap32(x)


//! @}


/*! \name ިݕϊ
 *
 * clzctz̏ꍇƓlKp܂AAVR32-GCC__builtin_bswap_16
 * __builtin_bswap_32͒萔ɓKpꂽϸۂ̂悤ɓÂɂ2
 * ϸۂ̑g`܂B:
 *   - 萔(َ߲Ɋm̒l)ɓKp邽߂Swap16ASwap32ASwap64
 *   - 萔(َ߲ɖm̒l)ɓKp邽߂swap16Aswap32Aswap64
 */
//! @{

/*! \brief (޲Čɂ)\a u16̴ި݋t]
 *
 * \param	u16		ި݂t]U16
 *
 * \return t]ި݂\a u16̌ʒl
 *
 * \note َ߲Ɋm̒lŎgp邾̏ꍇɂƍœK
 */
#define Swap16(u16) ((U16)(((U16)(u16) >> 8) |\
                           ((U16)(u16) << 8)))

/*! \brief (޲Čɂ)\a u32̴ި݋t]
 *
 * \param	u32		ި݂t]U32
 *
 * \return t]ި݂\a u32̌ʒl
 *
 * \note َ߲Ɋm̒lŎgp邾̏ꍇɂƍœK
 */
#define Swap32(u32) ((U32)(((U32)Swap16((U32)(u32) >> 16)) |\
                           ((U32)Swap16((U32)(u32)) << 16)))

/*! \brief (޲Čɂ)\a u64̴ި݋t]
 *
 * \param	u64		ި݂t]U64
 *
 * \return t]ި݂\a u64̌ʒl
 *
 * \note َ߲Ɋm̒lŎgp邾̏ꍇɂƍœK
 */
#define Swap64(u64) ((U64)(((U64)Swap32((U64)(u64) >> 32)) |\
                           ((U64)Swap32((U64)(u64)) << 32)))

/*! \brief (޲Čɂ)\a u16̴ި݋t]
 *
 * \param	u16		ި݂t]U16
 *
 * \return t]ި݂\a u16̌ʒl
 *
 * \note َ߲Ɋm̒lŎgp邾̏ꍇɂƍœK
 */
#define swap16(u16) Swap16(u16)

/*! \brief (޲Čɂ)\a u32̴ި݋t]
 *
 * \param	u32		ި݂t]U32
 *
 * \return t]ި݂\a u32̌ʒl
 *
 * \note َ߲Ɋm̒lŎgp邾̏ꍇɂƍœK
 */
#define swap32(u32) Swap32(u32)

/*! \brief (޲Čɂ)\a u64̴ި݋t]
 *
 * \param	u64		ި݂t]U64
 *
 * \return t]ި݂\a u64̌ʒl
 *
 * \note َ߲Ɋm̒lŎgp邾̏ꍇɂƍœK
 */
#define swap64(u64) ((U64)(((U64)swap32((U64)(u64) >> 32)) |\
                           ((U64)swap32((U64)(u64)) << 32)))

//! @}


/*! \name ڕWۉ
 */
//! @{

#define _GLOBEXT_			extern		//!< OL׽wq
#define _CONST_TYPE_		const		//!< const^Cq
#define _MEM_TYPE_SLOW_					//!< ᑬ،^
#define _MEM_TYPE_MEDFAST_				//!< Ȃ荂،^
#define _MEM_TYPE_FAST_					//!< ،^

typedef U8					Byte;		//!< 8ޯĕȂ

#define memcmp_ram2ram		memcmp		//!< RAMRAMԂ̖ړIΏۓLmemcmp
#define memcmp_code2ram		memcmp		//!< RAMNVRAM̖ړIΏۓLmemcmp
#define memcpy_ram2ram		memcpy		//!< RAMRAMւ̖ړIΏۓLmemcpy
#define memcpy_code2ram		memcpy		//!< NVRAMRAMւ̖ړIΏۓLmemcpy

//! @}

/**
 * \brief Zgp\f$ \left\lceil \frac{a}{b} \right\rceil \f$vZ
 *
 * \param	a	
 * \param	b	ʂ̐
 *
 * \return ł߂Ɋۂߏグꂽ(\a a / \a b)
 */
#define div_ceil(a, b)	(((a) + (b) - 1) / (b))

#include "preprocessor.h"
#include "progmem.h"
#include "interrupt.h"

/**
 * \}
 */

#endif  // UTILS_COMPILER_H
